VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Area"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Version of Class
Private myVersion As Integer
' Unique index for this Area
Private myIndex As Integer
' Name of this Area
Private myName As String
' File Name for this Area
Private myFileName As String
' Flag for if Loaded into Memory or not (not saved)
Private myIsLoaded As Integer
' Plot reference (not saved)
Private myPlot As Plot

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewIndex As Integer)
    myIndex = NewIndex
End Property

Public Property Get IsLoaded() As Integer
    IsLoaded = myIsLoaded
End Property

Public Property Let IsLoaded(NewValue As Integer)
    myIsLoaded = NewValue
End Property

Public Property Get Name() As String
    Name = Trim(myName)
End Property

Public Property Let Name(NewText As String)
    myName = Trim(NewText)
End Property

Public Property Get FileName() As String
    FileName = Trim(myFileName)
End Property

Public Property Let FileName(NewText As String)
    myFileName = Trim(NewText)
End Property

Public Property Get Plot() As Plot
    Set Plot = myPlot
End Property

Public Property Set Plot(NewValue As Plot)
    Set myPlot = NewValue
End Property

Public Sub Copy(FromArea As Area)
    myName = FromArea.Name
    Set myPlot = FromArea.Plot
End Sub

Public Sub ReadFromFile(FromFile As Integer)
    Dim c As Integer, Cnt As Long
    ' Read Name
    Get FromFile, , myVersion
    Get FromFile, , Cnt
    myName = ""
    For c = 1 To Cnt
        myName = myName & " "
    Next c
    Get FromFile, , myName
    ' Read FileName
    Get FromFile, , Cnt
    myFileName = ""
    For c = 1 To Cnt
        myFileName = myFileName & " "
    Next c
    Get FromFile, , myFileName
    ' Read Index
    Get FromFile, , myIndex
End Sub

Public Sub SaveToFile(ToFile As Integer)
    Dim c As Integer
    ' Save Name, FileName and Index
    Put ToFile, , myVersion
    Put ToFile, , Len(myName)
    Put ToFile, , myName
    Put ToFile, , Len(myFileName)
    Put ToFile, , myFileName
    Put ToFile, , myIndex
End Sub

Private Sub Class_Initialize()
    myFileName = "Not Saved"
    myIsLoaded = False
    Set myPlot = New Plot
End Sub
