VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Conversation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Version number of Class
Private myVersion As Integer
' Unique index of the Package
Private myIndex As Integer
' Name of the Convo Package
Private myName As String
' Description when first approach
Private myFirstTalk As String
' Description for any approach after the first (blank if NA)
Private mySecondTalk As String
' Pointer to Reply (not saved)
Private myReply As Integer
' &H1   - On = Have Talked, Off = Have not
' &H2   - Not Used
Private myFlags As Byte
' Collection of Topics in this Package
Private myTopics As New Collection

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewValue As Integer)
    myIndex = NewValue
End Property

Public Property Get Reply() As Integer
    Reply = myReply
End Property

Public Property Let Reply(NewValue As Integer)
    myReply = NewValue
End Property

Public Property Get Flags() As Integer
    Flags = myFlags
End Property

Public Property Let Flags(NewValue As Integer)
    myFlags = NewValue
End Property

Public Property Get Name() As String
    Name = Trim(myName)
End Property

Public Property Let Name(NewName As String)
    myName = Trim(NewName)
End Property

Public Property Get FirstTalk() As String
    FirstTalk = Trim(myFirstTalk)
End Property

Public Property Let FirstTalk(NewValue As String)
    myFirstTalk = Trim(NewValue)
End Property

Public Property Get SecondTalk() As String
    SecondTalk = Trim(mySecondTalk)
End Property

Public Property Let SecondTalk(NewValue As String)
    mySecondTalk = Trim(NewValue)
End Property

Public Property Get HaveTalked() As Integer
    HaveTalked = (myFlags And &H1) > 0
End Property

Public Property Let HaveTalked(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H1
    Else
        myFlags = myFlags And (Not &H1)
    End If
End Property

Public Property Get Topics() As Collection
    Set Topics = myTopics
End Property

Public Function AddTopic() As Topic
    ' Adds a Topic and returns a reference to that Topic
    Dim c As Integer
    Dim TopicX As Topic
    ' Find new available unused index idenifier
    c = 1
    For Each TopicX In myTopics
        If TopicX.Index >= c Then
            c = TopicX.Index + 1
        End If
    Next TopicX
    ' Set the index and add the Topic.
    Set TopicX = New Topic
    TopicX.Index = c
    TopicX.Say = "Topic" & c
    myTopics.Add Item:=TopicX, Key:="Q" & TopicX.Index
    Set AddTopic = TopicX
End Function

Public Sub RemoveTopic(DeleteKey As String)
    myTopics.Remove DeleteKey
End Sub

Public Sub Copy(FromConversation As Conversation)
    Dim c As Integer
    Dim TopicX As Topic
    ' Copy Conversation Name
    myName = FromConversation.Name
    myFirstTalk = FromConversation.FirstTalk
    mySecondTalk = FromConversation.SecondTalk
    myFlags = FromConversation.Flags
    ' Copy Topics for Conversation
    Set myTopics = New Collection
    For c = 1 To FromConversation.Topics.Count
        Set TopicX = Me.AddTopic
        TopicX.Copy FromConversation.Topics(c)
    Next c
End Sub

Public Sub ReadFromFile(FromFile As Integer)
    Dim c As Integer, Cnt As Long
    Dim TopicX As Topic
    ' Read Conversation Name and Index
    Get FromFile, , myVersion
    Get FromFile, , myIndex
    Get FromFile, , Cnt
    myName = ""
    For c = 1 To Cnt
        myName = myName & " "
    Next c
    Get FromFile, , myName
    ' Read Talk Text
    Get FromFile, , Cnt
    myFirstTalk = ""
    For c = 1 To Cnt
        myFirstTalk = myFirstTalk & " "
    Next c
    Get FromFile, , myFirstTalk
    Get FromFile, , Cnt
    mySecondTalk = ""
    For c = 1 To Cnt
        mySecondTalk = mySecondTalk & " "
    Next c
    Get FromFile, , mySecondTalk
    Get FromFile, , myFlags
    ' Read Topics for Conversation
    Get FromFile, , Cnt
    For c = 1 To Cnt
        Set TopicX = New Topic
        TopicX.ReadFromFile FromFile
        myTopics.Add Item:=TopicX, Key:="Q" & TopicX.Index
    Next c
End Sub

Public Sub SaveToFile(ToFile As Integer)
    Dim c As Integer
    ' Save Conversation
    Put ToFile, , myVersion
    Put ToFile, , myIndex
    Put ToFile, , Len(myName)
    Put ToFile, , myName
    Put ToFile, , Len(myFirstTalk)
    Put ToFile, , myFirstTalk
    Put ToFile, , Len(mySecondTalk)
    Put ToFile, , mySecondTalk
    Put ToFile, , myFlags
    ' Save Topics for Conversation
    Put ToFile, , myTopics.Count
    For c = 1 To myTopics.Count
        myTopics(c).SaveToFile ToFile
    Next c
End Sub

Private Sub Class_Initialize()
    myName = "Undefined"
End Sub
