Attribute VB_Name = "modDM"
Option Explicit

Public TriggerStatementState As Integer

Public Syntax(bdStatementCount, 7) As String, SyntaxIndex(bdStatementCount, 7) As Byte

Public Const bdTrigAll As Integer = 0
Public Const bdTrigEncounter As Integer = 1
Public Const bdTrigItem As Integer = 2
Public Const bdTrigCreatureSkill As Integer = 3
Public Const bdTrigCreature As Integer = 4
Public Const bdTrigTopic As Integer = 5
Public Const bdTrigTheme As Integer = 6
Public Const bdTrigTome As Integer = 7
Public Const bdTrigTrig As Integer = 8
Public Const bdTrigTile As Integer = 9

Public Const bdEditMap As Integer = 1
Public Const bdEditDoor As Integer = 2
Public Const bdEditEncounter As Integer = 3
Public Const bdEditCreature As Integer = 4
Public Const bdEditItem As Integer = 5
Public Const bdEditTrigger As Integer = 6
Public Const bdEditStatement As Integer = 7
Public Const bdEditTile As Integer = 8
Public Const bdEditConvo As Integer = 9
Public Const bdEditTopic As Integer = 10
Public Const bdEditTheme As Integer = 11
Public Const bdEditMapGraphic As Integer = 12
Public Const bdEditMapDoors As Integer = 13
Public Const bdEditMapThemes As Integer = 14
Public Const bdEditMapEncounters As Integer = 15
Public Const bdEditTileSet As Integer = 16
Public Const bdEditSkill As Integer = 17
Public Const bdEditFactoid As Integer = 18
Public Const bdEditMapTileSets As Integer = 19
Public Const bdEditMapTiles As Integer = 20
Public Const bdEditTome As Integer = 21
Public Const bdEditTomeParty As Integer = 22
Public Const bdEditTomeJournals As Integer = 23
Public Const bdEditTomeTriggers As Integer = 24
Public Const bdEditEntryPoint As Integer = 25
Public Const bdEditMapEntryPoints As Integer = 26
Public Const bdEditTomeAreas As Integer = 27
Public Const bdEditArea As Integer = 28
Public Const bdEditJournal As Integer = 29
Public Const bdEditTomeFactoids As Integer = 30

Type TileList
    TileX As Tile
    x As Integer
    y As Integer
End Type

Public Sub PlayMusic(ByVal SongName As String, Optional AlternatePath As Variant)
    Dim c As Integer, FileName As String
    On Error GoTo ErrorHandler
    ' Fade out song
'    c = mciSendString("close songnow", 0&, 0, 0)
    ' Fade in here
    ' Find location of Song
    FileName = Dir(App.Path & "\data\music\" & SongName)
    If FileName = "" Then
        FileName = Dir(App.Path & "\data\music\combat\" & SongName)
        If FileName = "" Then
            FileName = Dir(App.Path & "\data\music\adventure\" & SongName)
            If FileName = "" And IsMissing(AlternatePath) = False Then
                FileName = Dir(AlternatePath & "\" & SongName)
                If FileName = "" Then
                    Exit Sub
                Else
                    ChDir AlternatePath
                End If
            Else
                ChDir App.Path & "\data\music\adventure"
            End If
        Else
            ChDir App.Path & "\data\music\combat"
        End If
    Else
        ChDir App.Path & "\data\music"
    End If
    ' Play MID with Windows Media Player
    On Error Resume Next
    frmMDI.MediaPlayerMusic.FileName = SongName
    frmMDI.MediaPlayerMusic.Play

ErrorHandler:
    Resume Next
'    c = mciSendString("open " & SongName & " type sequencer alias songnow", 0&, 0, 0)
'    c = mciSendString("play songnow", 0&, 0, 0)
'
'    Dim RetMidi As Long
'    Dim RetString As String
'    Dim CallBack As Long
'
'    Dim Length As Single
'    Dim PercentDone As Single
'    Dim Restart
'
'    RetString = Space$(128)
'    RetMidi = mciSendString("status midi length", RetString, 128, CallBack)
'    If Val(RetString) Then
'        Length = Val(RetString)
'        RetMidi = mciSendString("status midi position", RetString, 128, CallBack)
'        PercentDone = Val(RetString) / Length
'
'        If PercentDone >= 1 Then
'            tmrCheckMusic.Enabled = False
'            Call Music_Play(CurrentMIDI)
'            Exit Sub
'        End If
'    Else
'        Exit Sub
'    End If

End Sub

Sub PlaySound(ByVal SoundName As String, Wait As Integer)
    Dim rc As Long, PauseUntil As Single, FileName As String
    On Error GoTo ErrorHandler
    ' If Sound Effects are off, then play nothing
    If GlobalWAVState = 0 Then
        Exit Sub
    End If
    ' If not ending in .wav, then do that now
    If Right(LCase(SoundName), 4) <> ".wav" Then
        SoundName = SoundName & ".wav"
    End If
    ' Find location of Song
    FileName = Dir(App.Path & "\data\sounds\" & SoundName)
    If FileName = "" Then
        FileName = Dir(frmMDI.Tome.FullPath & "\" & SoundName)
        If FileName = "" Then
            Exit Sub
        Else
            FileName = frmMDI.Tome.FullPath & "\" & SoundName
        End If
    Else
        FileName = App.Path & "\data\sounds\" & SoundName
    End If
    ' Play the Sound file
    'SND_SYNC      = &H00 Program loses control until the sound ends
    'SND_ASYN      = &H01 Program gets back control.
    'SND_NODEFAULT = &H02 Don't beep if can't find sound.
    'SND_LOOP      = &H08 Play until called again with WaveFile = ""
    'SND_NOSTOP    = &H10 If sound is already playing, return false and don't play.
    If Wait Then
        PauseUntil = Timer + 5
        Do Until rc = 1 Or Timer > PauseUntil
            rc = sndPlaySound(FileName, &H10)
        Loop
    Else
        rc = sndPlaySound(FileName, &H1)
    End If
ErrorHandler:
    Resume Next
End Sub

Public Sub BuildTriggerList(cmbTriggerList As ComboBox, TrigType As Integer)
    Dim c As Integer
    For c = 0 To 77
        Select Case TrigType
        
            Case bdTrigTome
                Select Case c
                    Case bdNone, bdPostTurnCycle, bdPostEnterTome, bdPreExitTome, bdPostApplyDamage, _
                        bdPreCombat, bdPostCombat, bdOnListen, bdOnRealTime
                        cmbTriggerList.AddItem TriggerName(c)
                        cmbTriggerList.ItemData(cmbTriggerList.NewIndex) = c
                End Select
                
            Case bdTrigTopic
                Select Case c
                    Case bdNone, bdPreTopic, bdPostTopic
                        cmbTriggerList.AddItem TriggerName(c)
                        cmbTriggerList.ItemData(cmbTriggerList.NewIndex) = c
                End Select
                
            Case bdTrigEncounter, bdTrigTheme
                Select Case c
                    Case bdNone, bdPostTurnCycle, bdPostEnterEncounter, bdPreSearch, bdPostSearch, _
                        bdPreTake, bdPostTake, bdPreUseInEncounter, bdPostUseInEncounter, _
                        bdOnIgnore, bdOnListen, bdPostStepEncounter, bdPreExitTome, bdPreCombat, _
                        bdPreSearchTraps, bdPostSearchTraps, bdPostCombat, bdPreEnterEncounter, _
                        bdPreUnlock, bdPreOpen, bdPreCombatStep, bdPostCombatStep, bdPreCast, bdOnRealTime
                        
                        cmbTriggerList.AddItem TriggerName(c)
                        cmbTriggerList.ItemData(cmbTriggerList.NewIndex) = c
                End Select
                
            Case bdTrigItem
                Select Case c
                    Case bdNone, bdPostTurnCycle, bdPreDropItem, bdPostDropItem, bdPreExamine, _
                        bdPostExamine, bdPreSplit, bdPostSplit, bdPreCombine, bdOnCombine, bdPostCombine, _
                        bdPreReady, bdPostReady, bdPreUnReady, bdPostUnReady, bdOnUseOnCreature, _
                        bdPreUseOnItem, bdOnUseOnItem, bdPostUseOnItem, bdOnUseInEncounter, _
                        bdPreRollAttack, bdPostRollAttack, bdPreRollArmorChit, bdPostRollArmorChit, _
                        bdPreAttacked, bdPostAttacked, bdPreRollDamage, bdPostRollDamage, _
                        bdPreApplyDamage, bdPostApplyDamage, bdPreDeath, bdPostDeath, _
                        bdPreCombatMove, bdPostCombatMove, bdPreSearchTraps, _
                        bdPostSearchTraps, bdPreTake, bdPostTake, bdPreTurn, bdPostTurn, _
                        bdPrePickLock, bdPreUnlock, bdPreSellItem, bdPostSellItem, _
                        bdPreBuyItem, bdPostBuyItem, bdPostAttack, bdPreCombatStep, _
                        bdPostCombatStep, bdPreCast
                        
                        cmbTriggerList.AddItem TriggerName(c)
                        cmbTriggerList.ItemData(cmbTriggerList.NewIndex) = c
                End Select
                
            Case bdTrigCreature
                Select Case c
                    Case bdNone, bdPostTurnCycle, bdPreUseOnCreature, bdPostUseOnCreature, _
                        bdOnAttack, bdOnSkillUse, bdOnCast, bdPostAttacked, bdPreRollAttack, _
                        bdPreReady, bdPostReady, bdPreUnReady, bdPostUnReady, _
                        bdPostRollAttack, bdPreRollArmorChit, bdPreAttacked, _
                        bdPreTurn, bdPostTurn, bdPreExamine, bdPostExamine, bdPrePickLock, _
                        bdPreSellItem, bdPostSellItem, bdPreBuyItem, bdPostBuyItem, _
                        bdPreSearchTraps, bdPostSearchTraps, bdPreDeath, bdPostDeath, _
                        bdPostNewCharacter, bdPostAttack, bdPreCombatStep, bdPostCombatStep, _
                        bdOnSkillTarget, bdOnCastTarget, bdPreCast, bdPreRollDamage, bdPostRollDamage, _
                        bdOnStatus, bdOnRealTime
                        
                        cmbTriggerList.AddItem TriggerName(c)
                        cmbTriggerList.ItemData(cmbTriggerList.NewIndex) = c
                End Select

            Case bdTrigTrig
                cmbTriggerList.AddItem TriggerName(c)
                cmbTriggerList.ItemData(cmbTriggerList.NewIndex) = c
        End Select
    Next c
End Sub

Public Function ParseStatement(TomeX As Tome, AreaX As Area, TrigX As Trigger, StmtX As Statement, ByVal Text As String) As String
    Dim c As Long, w As Integer, j As Integer, k As Integer, i As Integer, Index As Integer, LastPos As Long
    Dim Found As Integer, w2 As Integer
    ' Strip out any extra spaces or spaces after an apostrophe (not a comment)
    c = 1
    Do Until c > Len(Text)
        If Mid(Text, c, 2) = "  " Then
            Text = Left(Text, c) & Mid(Text, c + 2)
        Else
            c = c + 1
        End If
    Loop
    Text = Trim(Text)
    ' If Text is now empty, exit without error
    If Len(Text) = 0 Then
        Exit Function
    End If
    ' Parse the statement
    c = 1: w = 0: LastPos = 1: ParseStatement = ""
    Do Until c > Len(Text) Or w > 7
        If Mid(Text, c, 1) = "\" Then c = c + 1
        If Mid(Text, c, 1) = " " Or c = Len(Text) Then
            If c = Len(Text) Then c = c + 1
            If w = 0 Then   ' Statement Type
                Found = False
                For i = 0 To bdStatementCount
                    If UCase(Mid(Text, LastPos, c - LastPos)) = UCase(Syntax(i, 0)) Then
                        StmtX.Statement = i
                        w = w + 1
                        Found = True
                        Exit For
                    End If
                Next i
                If Found = False Then
                    ParseStatement = "Error: Invalid statement type (" & Mid(Text, LastPos, c - LastPos) & ")"
                    Exit Function
                End If
            Else    ' Additional Syntax
                Index = SyntaxIndex(StmtX.Statement, w)
                Select Case Syntax(StmtX.Statement, w)
                    Case "Var"  ' Context.Var
                        k = InStr(LastPos + 1, Text, ".")
                        If k > 0 Then
                            ' Context
                            Found = False
                            For i = 0 To 32
                                If UCase(Trim(Mid(Text, LastPos, k - LastPos))) = UCase(ContextToText(i)) Then
                                    StmtX.B(Index) = i
                                    Found = True
                                    Exit For
                                End If
                            Next i
                            If Found = False Then
                                ParseStatement = "Error: Invalid variable object (" & Mid(Text, LastPos, k - LastPos) & ")"
                                Exit Function
                            End If
                            ' Var
                            Found = False
                            For i = 0 To 255
                                If UCase(Trim(Mid(Text, k + 1, c - k - 1))) = UCase(VarToText(StmtX.B(Index), i)) Then
                                    StmtX.B(Index + 1) = i
                                    Found = True
                                    w = w + 1
                                End If
                            Next i
                            If Found = False Then
                                ParseStatement = "Error: Invalid variable property (" & Mid(Text, k + 1, c - k - 1) & ")?"
                                Exit Function
                            End If
                        Else
                            ParseStatement = "Error: Expected a variable object"
                            Exit Function
                        End If
                    Case "Op"   ' Operator
                        Found = False
                        For i = 0 To 13
                            If UCase(Trim(Mid(Text, LastPos, c - LastPos))) = UCase(OpToText(i)) Then
                                StmtX.B(Index) = i
                                Found = True
                                w = w + 1
                                Exit For
                            End If
                        Next i
                        If Found = False Then
                            ParseStatement = "Error: Invalid operator (" & Mid(Text, LastPos, c - LastPos) & ")"
                            Exit Function
                        End If
                    Case "Text1", "Text2", "Text3", "Text4" ' Text
                        ' Check for starting single quote
                        If Mid(Text, LastPos, 1) = Chr(34) Then
                            ' Check for ending single quote
                            k = InStr(LastPos + 1, Text, Chr(34))
                            If k > 0 Then
                                Select Case Index
                                    Case 0
                                        If Len(StmtX.Text) > 0 Then
                                            StmtX.Text = Mid(Text, LastPos + 1, k - LastPos - 1) & StmtX.Text
                                        Else
                                            StmtX.Text = Mid(Text, LastPos + 1, k - LastPos - 1)
                                        End If
                                    Case 1
                                        StmtX.Text = StmtX.Text & "|" & Mid(Text, LastPos + 1, k - LastPos - 1)
                                End Select
                                w = w + 1
                                c = k + 1
                            Else
                                ParseStatement = "Error: Expected an ending quote"
                                Exit Function
                            End If
                        Else
                            ParseStatement = "Error: Expected a starting quote"
                            Exit Function
                        End If
                    Case "List1", "List2", "List3", "List4"  ' List Match
                        ' If quoted list element, then resolve the end position
                        If Mid(Text, LastPos, 1) = Chr(34) Then
                            c = InStr(LastPos + 1, Text, Chr(34)) + 1
                            If c = 0 Then
                                ParseStatement = "Error: Expected an ending quote"
                                Exit Function
                            End If
                        End If
                        StatementToList TomeX, AreaX, TrigX, StmtX, ListIndex(), List()
                        k = Right(Syntax(StmtX.Statement, w), 1) - 1
                        Found = False
                        For i = 0 To ListIndex(k)
                            If UCase(Trim(Mid(Text, LastPos, c - LastPos))) = UCase(List(k, i)) Then
                                StmtX.B(Index) = i
                                Found = True
                                w = w + 1
                                Exit For
                            End If
                        Next i
                        If Found = False Then
                            ParseStatement = "Error: Invalid object reference (" & Mid(Text, LastPos, c - LastPos) & ")"
                            Exit Function
                        End If
                    Case "(Var)"
                        ' Check for starting single paren
                        If Mid(Text, LastPos, 1) = "(" Then
                            ' Check for ending single quote
                            k = InStr(LastPos + 1, Text, ")")
                            If k > 0 Then
                                LastPos = LastPos + 1
                                c = LastPos: w2 = 0
                                Do While c <= k
                                    If Mid(Text, c, 1) = "," Or c = k Then
                                        j = InStr(LastPos + 1, Text, ".")
                                        If j > 0 Then
                                            ' Context
                                            Found = False
                                            For i = 0 To 32
                                                If UCase(Trim(Mid(Text, LastPos, j - LastPos))) = UCase(ContextToText(i)) Then
                                                    StmtX.B(Index + w2) = i
                                                    Found = True
                                                    Exit For
                                                End If
                                            Next i
                                            If Found = False Then
                                                ParseStatement = "Error: Invalid variable object (" & Mid(Text, LastPos, j - LastPos) & ")"
                                                Exit Function
                                            End If
                                            ' Var
                                            Found = False
                                            For i = 0 To 255
                                                If UCase(Trim(Mid(Text, j + 1, c - j - 1))) = UCase(VarToText(StmtX.B(Index + w2), i)) Then
                                                    StmtX.B(Index + w2 + 1) = i
                                                    w2 = w2 + 3
                                                    LastPos = c + 1
                                                    Found = True
                                                    Exit For
                                                End If
                                            Next i
                                            If Found = False Then
                                                ParseStatement = "Error: Invalid variable property (" & Mid(Text, j + 1, c - j - 1) & ")?"
                                                Exit Function
                                            End If
                                        Else
                                            ParseStatement = "Error: Expected a variable object"
                                            Exit Function
                                        End If
                                    End If
                                    c = c + 1
                                Loop
                                w = w + 1
                                c = k + 1
                            Else
                                ParseStatement = "Error: Expected an ending parenthesis"
                                Exit Function
                            End If
                        Else
                            ParseStatement = "Error: Expected a starting parenthesis"
                            Exit Function
                        End If
                    Case "(List)"
                        ' Check for starting single paren
                        If Mid(Text, LastPos, 1) = "(" Then
                            ' Check for ending single quote
                            k = InStr(LastPos + 1, Text, ")")
                            If k > 0 Then
                                LastPos = LastPos + 1
                                c = LastPos: w2 = 0
                                StatementToList TomeX, AreaX, TrigX, StmtX, ListIndex(), List()
                                Do While c <= k And w2 < 6
                                    If Mid(Text, c, 1) = "," Or c = k Then
                                        Found = False
                                        For i = 0 To ListIndex(0)
                                            If UCase(Trim(Mid(Text, LastPos, c - LastPos))) = UCase(List(0, i)) Then
                                                StmtX.B(Index + w2) = i
                                                Found = True
                                                w2 = w2 + 1
                                                LastPos = c + 1
                                                Exit For
                                            End If
                                        Next i
                                        If Found = False Then
                                            ParseStatement = "Error: Invalid object reference (" & Mid(Text, LastPos, c - LastPos) & ")"
                                            Exit Function
                                        End If
                                    End If
                                    c = c + 1
                                Loop
                                w = w + 1
                                c = k + 1
                            Else
                                ParseStatement = "Error: Expected an ending parenthesis"
                                Exit Function
                            End If
                        Else
                            ParseStatement = "Error: Expected a starting parenthesis"
                            Exit Function
                        End If
                    Case "Spec" ' Special Parsing
                        Select Case StmtX.Statement
                            Case 54 '' Text
                                StmtX.Text = Mid(Text, LastPos)
                                c = Len(Text)
                                w = w + 1
                        End Select
                    Case Else   ' Other expected/allowed tokens
                        If UCase(Mid(Text, LastPos, c - LastPos)) = UCase(Syntax(StmtX.Statement, w)) Then
                            If w >= SyntaxIndex(StmtX.Statement, 0) Then
                                StmtX.B(Index) = 1
                            End If
                            w = w + 1
                        Else
                           ParseStatement = "Error: Expected '" & Syntax(StmtX.Statement, w) & "' instead of '" & Mid(Text, LastPos, c - LastPos) & "'"
                           Exit Function
                        End If
                End Select
            End If
            LastPos = c + 1
        End If
        c = c + 1
    Loop
    ' Check to make sure completed the syntax
    If w > 8 Then
        ParseStatement = "Error: Syntax error"
        Exit Function
    End If
    If SyntaxIndex(StmtX.Statement, 0) > w Then
        ParseStatement = "Error: Unexpected end of statement"
        Exit Function
    End If
End Function

Public Sub BuildSyntax()
    ' Syntax building for parsing trigger statements. The first SyntaxIndex() indicates
    ' how many required pieces of the syntax there are for the statement.
    ' The other SyntaxIndex() value tell where to put the piece into the Statement object.
    Dim c As Integer
    For c = 0 To bdStatementCount
        Select Case c
            Case 0  'None
                Syntax(c, 0) = "": SyntaxIndex(c, 0) = 0
            Case 1  'Label [Context.Var]
                Syntax(c, 0) = "Label": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
            Case 2  'If [Context.Var] [Op] [Context.Var]
                Syntax(c, 0) = "If": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Op": SyntaxIndex(c, 2) = 2
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 3
            Case 3  'Else
                Syntax(c, 0) = "Else": SyntaxIndex(c, 0) = 0
            Case 4  'ElseIf [Context.Var] [Op] [Context.Var]
                Syntax(c, 0) = "ElseIf": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Op": SyntaxIndex(c, 2) = 2
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 3
            Case 5  'And [Context.Var] [Op] [Context.Var]
                Syntax(c, 0) = "And": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Op": SyntaxIndex(c, 2) = 2
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 3
            Case 6  'Or [Context.Var] [Op] [Context.Var]
                Syntax(c, 0) = "Or": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Op": SyntaxIndex(c, 2) = 2
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 3
            Case 7  'EndIf
                Syntax(c, 0) = "EndIf": SyntaxIndex(c, 0) = 0
            Case 8  'While [Context.Var] [Op] [Context.Var]
                Syntax(c, 0) = "While": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Op": SyntaxIndex(c, 2) = 2
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 3
            Case 9  'ForEach [List] In [List]
                Syntax(c, 0) = "ForEach": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "In"
                Syntax(c, 3) = "List2": SyntaxIndex(c, 3) = 1
            Case 10 'Next
                Syntax(c, 0) = "Next": SyntaxIndex(c, 0) = 0
            Case 11 'Branch [Context.Var]
                Syntax(c, 0) = "Branch": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
            Case 12 'Put [Context.Var] [Op] [Context.Var] Into [Context.Var]
                Syntax(c, 0) = "Put": SyntaxIndex(c, 0) = 5
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Op": SyntaxIndex(c, 2) = 2
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 3
                Syntax(c, 4) = "Into"
                Syntax(c, 5) = "Var": SyntaxIndex(c, 5) = 5
            Case 13 'Set [List] = [List]
                Syntax(c, 0) = "Set": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "="
                Syntax(c, 3) = "List2": SyntaxIndex(c, 3) = 1
            Case 14 'Select [Context.Var]
                Syntax(c, 0) = "Select": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
            Case 15 'Case [Context.Var]
                Syntax(c, 0) = "Case": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
            Case 16 'EndSelect
                Syntax(c, 0) = "EndSelect": SyntaxIndex(c, 0) = 0
            Case 17 'Exit [List]
                Syntax(c, 0) = "Exit": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
            Case 18 'CopyCreature [List] Into [List]
                Syntax(c, 0) = "CopyCreature": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Into"
                Syntax(c, 3) = "List2": SyntaxIndex(c, 3) = 1
            Case 19 'CopyItem [List] Into [List]
                Syntax(c, 0) = "CopyItem": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Into"
                Syntax(c, 3) = "List2": SyntaxIndex(c, 3) = 1
            Case 20 'CopyTrigger [List] Into [List]
                Syntax(c, 0) = "CopyTrigger": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Into"
                Syntax(c, 3) = "List2": SyntaxIndex(c, 3) = 1
            Case 21 'CopyTile 'Text' Level [List] At ([Context.Var],[Context.Var])
                Syntax(c, 0) = "CopyTile": SyntaxIndex(c, 0) = 5
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Level"
                Syntax(c, 3) = "List1": SyntaxIndex(c, 3) = 2
                Syntax(c, 4) = "At"
                Syntax(c, 5) = "(Var)": SyntaxIndex(c, 5) = 0
            Case 22 'CopyText 'Text' Into [Context.Var]
                Syntax(c, 0) = "CopyText": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Into"
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 0
            Case 23 'Runes ([List],[List],[List],[List],[List],[List]) [List]
                Syntax(c, 0) = "Runes": SyntaxIndex(c, 0) = 2
                Syntax(c, 1) = "(List)": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "List2": SyntaxIndex(c, 2) = 6
            Case 24 'AddFactoid 'Text'
                Syntax(c, 0) = "AddFactoid": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
            Case 25 'AddJournalEntry 'Text'
                Syntax(c, 0) = "AddJournalEntry": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Text2": SyntaxIndex(c, 1) = 0
            Case 26 'Destroy [List] In [List]
                Syntax(c, 0) = "Destroy": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "In"
                Syntax(c, 3) = "List2": SyntaxIndex(c, 3) = 1
            Case 27 'CombatApplyDamage [Context.Var] To [List]
                Syntax(c, 0) = "CombatApplyDamage": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 3
                Syntax(c, 2) = "To"
                Syntax(c, 3) = "List1": SyntaxIndex(c, 3) = 0
            Case 28 'CombatRollAttack [List] Bonus [Context.Var]
                Syntax(c, 0) = "CombatRollAttack": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 5
                Syntax(c, 2) = "Bonus"
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 0
            Case 29 'CombatRollDamage [Context.Var] As [List] Check
                Syntax(c, 0) = "CombatRollDamage": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 5
                Syntax(c, 2) = "Damaged"
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 0
                Syntax(c, 4) = "Check": SyntaxIndex(c, 4) = 2
            Case 30 'DestroyFactoid 'Text'
                Syntax(c, 0) = "DestroyFactoid": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
            Case 31 'TargetCreature [List] As [List] Within [Context.Var] Dead
                Syntax(c, 0) = "TargetCreature": SyntaxIndex(c, 0) = 5
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "In"
                Syntax(c, 3) = "List2": SyntaxIndex(c, 3) = 1
                Syntax(c, 4) = "Within"
                Syntax(c, 5) = "Var": SyntaxIndex(c, 5) = 3
                Syntax(c, 6) = "Dead": SyntaxIndex(c, 6) = 2
            Case 32 'TargetItem [List]
                Syntax(c, 0) = "TargetItem": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
            Case 33 'PlaySound 'Text' Pause
                Syntax(c, 0) = "PlaySound": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Text3": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Pause": SyntaxIndex(c, 2) = 0
            Case 34 'PlayMusic 'Text' Pause
                Syntax(c, 0) = "PlayMusic": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Text3": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Pause": SyntaxIndex(c, 2) = 0
            Case 35 'MoveParty To [List] At ([Context.Var],[Context.Var])
                Syntax(c, 0) = "MoveParty": SyntaxIndex(c, 0) = 4
                Syntax(c, 1) = "To"
                Syntax(c, 2) = "List1": SyntaxIndex(c, 2) = 5
                Syntax(c, 3) = "At"
                Syntax(c, 4) = "(Var)": SyntaxIndex(c, 4) = 0
            Case 36 'DialogShow 'Text' [List] Says 'Text'
                Syntax(c, 0) = "DialogShow": SyntaxIndex(c, 0) = 4
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "List1": SyntaxIndex(c, 2) = 0
                Syntax(c, 3) = "Says"
                Syntax(c, 4) = "Text2": SyntaxIndex(c, 4) = 1
            Case 37 'DialogReply 'Text'
                Syntax(c, 0) = "DialogReply": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Text2": SyntaxIndex(c, 1) = 0
            Case 38 'DialogAccept [Context.Var]
                Syntax(c, 0) = "DialogAccept": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
            Case 39 'DialogDice 'Text' [List] Says 'Text' Into [Context.Var]
                Syntax(c, 0) = "DialogDice": SyntaxIndex(c, 0) = 6
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "List1": SyntaxIndex(c, 2) = 2
                Syntax(c, 3) = "Says"
                Syntax(c, 4) = "Text2": SyntaxIndex(c, 4) = 1
                Syntax(c, 5) = "Into"
                Syntax(c, 6) = "Var": SyntaxIndex(c, 6) = 0
            Case 40 'DialogHide
                Syntax(c, 0) = "DialogHide": SyntaxIndex(c, 0) = 0
            Case 41 'CutScene 'Text' Picture 'Text' As [List]
                Syntax(c, 0) = "CutScene": SyntaxIndex(c, 0) = 5
                Syntax(c, 1) = "Text2": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Picture"
                Syntax(c, 3) = "Text3": SyntaxIndex(c, 3) = 1
                Syntax(c, 4) = "As"
                Syntax(c, 5) = "List1": SyntaxIndex(c, 5) = 0
            Case 42 'QueRunes ([List],[List],[List],[List],[List],[List]) Check
                Syntax(c, 0) = "QueRunes": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "(List)": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Check": SyntaxIndex(c, 2) = 6
            Case 43 'CombatMove [List] [List]
                Syntax(c, 0) = "CombatMove": SyntaxIndex(c, 0) = 2
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "List2": SyntaxIndex(c, 2) = 1
            Case 44 'Reserved
            Case 45 'CombatTarget [List]
                Syntax(c, 0) = "CombatTarget": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
            Case 46 'PlaySFX 'Text' As [List] [List] [List] Frames 'Text'
                Syntax(c, 0) = "PlaySFX": SyntaxIndex(c, 0) = 7
                Syntax(c, 1) = "Text3": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "As"
                Syntax(c, 3) = "List1": SyntaxIndex(c, 3) = 0
                Syntax(c, 4) = "List2": SyntaxIndex(c, 4) = 1
                Syntax(c, 5) = "List3": SyntaxIndex(c, 5) = 2
                Syntax(c, 6) = "Frames"
                Syntax(c, 7) = "List4": SyntaxIndex(c, 7) = 3
            Case 47 'Sorcery [Context.Var]
                Syntax(c, 0) = "Sorcery": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
            Case 48 'DialogBuySell [List] At [Context.Var]
                Syntax(c, 0) = "DialogBuySell": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 2
                Syntax(c, 2) = "Rate"
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 0
            Case 49 'Reserved
            Case 50 'ExecTrigger [List]
                Syntax(c, 0) = "ExecTrigger": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
            Case 51 'DialogAcceptText [Context.Var]
                Syntax(c, 0) = "DialogAcceptText": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
            Case 52 'CombatStart
                Syntax(c, 0) = "CombatStart": SyntaxIndex(c, 0) = 1
            Case 53 'Let [Context.Var] = [Context.Var]
                Syntax(c, 0) = "Let": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "="
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 3
            Case 54 '' Text
                Syntax(c, 0) = "'": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Spec"
            Case 55 'RandomizeEncounter 'Text'
                Syntax(c, 0) = "RandomizeEncounter": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
            Case 56 'RandomTheme 'Text'
                Syntax(c, 0) = "RandomTheme": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
            Case 57 'AwardExperience [Context.Var] To [List]
                Syntax(c, 0) = "AwardExperience": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 5
                Syntax(c, 2) = "To"
                Syntax(c, 3) = "List1": SyntaxIndex(c, 3) = 0
            Case 58 'MoveItem [List] From [List] To [List] Copy
                Syntax(c, 0) = "MoveItem": SyntaxIndex(c, 0) = 5
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "From"
                Syntax(c, 3) = "List2": SyntaxIndex(c, 3) = 1
                Syntax(c, 4) = "To"
                Syntax(c, 5) = "List3": SyntaxIndex(c, 5) = 3
                Syntax(c, 6) = "Copy": SyntaxIndex(c, 6) = 2
            Case 59 'AddQuest 'Text' As 'Text'
                Syntax(c, 0) = "AddQuest": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "As"
                Syntax(c, 3) = "Text2": SyntaxIndex(c, 3) = 1
            Case 60 'RemoveQuest 'Text'
                Syntax(c, 0) = "RemoveQuest": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
            Case 61 'Reserved
            Case 62 'CombatAttackWithWeapon
                Syntax(c, 0) = "CombatAttackWithWeapon": SyntaxIndex(c, 0) = 0
            Case 63 'CombatAtackWithSpecial 'Text' As [Context.Var]
                Syntax(c, 0) = "CombatAtackWithSpecial": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "As"
                Syntax(c, 3) = "Var": SyntaxIndex(c, 3) = 5
            Case 64 'MovePartyMapName To 'Text' [List] At ([Context.Var],[Context.Var])
                Syntax(c, 0) = "MovePartyMapName": SyntaxIndex(c, 0) = 5
                Syntax(c, 1) = "To"
                Syntax(c, 2) = "Text1": SyntaxIndex(c, 2) = 0
                Syntax(c, 3) = "List1": SyntaxIndex(c, 3) = 2
                Syntax(c, 4) = "At"
                Syntax(c, 5) = "(Var)": SyntaxIndex(c, 5) = 0
            Case 65 'MoveCreature [List] From [List] To [List] Copy
                Syntax(c, 0) = "MoveCreature": SyntaxIndex(c, 0) = 5
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "From"
                Syntax(c, 3) = "List2": SyntaxIndex(c, 3) = 1
                Syntax(c, 4) = "To"
                Syntax(c, 5) = "List3": SyntaxIndex(c, 5) = 3
                Syntax(c, 6) = "Copy": SyntaxIndex(c, 6) = 2
            Case 66 'IfText [Context.Var] [Op] 'Text'
                Syntax(c, 0) = "IfText": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "Var": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Op": SyntaxIndex(c, 2) = 2
                Syntax(c, 3) = "Text4": SyntaxIndex(c, 3) = 0
            Case 67 'TargetEncounter 'Text'
                Syntax(c, 0) = "TargetEncounter": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Text1": SyntaxIndex(c, 1) = 0
            Case 68 'TargetTile At ([Context.Var],[Context.Var])
                Syntax(c, 0) = "TargetTile": SyntaxIndex(c, 0) = 2
                Syntax(c, 1) = "At"
                Syntax(c, 2) = "(Var)": SyntaxIndex(c, 2) = 0
            Case 69 'PlayVideo 'Text' Pause
                Syntax(c, 0) = "PlayVideo": SyntaxIndex(c, 0) = 1
                Syntax(c, 1) = "Text3": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Pause": SyntaxIndex(c, 2) = 0
            Case 70 'Find [List] Named 'Text' In [List]
                Syntax(c, 0) = "Find": SyntaxIndex(c, 0) = 5
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "In"
                Syntax(c, 3) = "List2": SyntaxIndex(c, 3) = 1
                Syntax(c, 4) = "Named"
                Syntax(c, 5) = "Text4": SyntaxIndex(c, 5) = 0
            Case 71 'CallTrigger [List] In [List]
                Syntax(c, 0) = "CallTrigger": SyntaxIndex(c, 0) = 3
                Syntax(c, 1) = "List1": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "In"
                Syntax(c, 3) = "List2": SyntaxIndex(c, 3) = 1
            Case 72 'CombatAnimation 'Text' For [List] Frames [List]
                Syntax(c, 0) = "CombatAnimation": SyntaxIndex(c, 0) = 5
                Syntax(c, 1) = "Text3": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "For"
                Syntax(c, 3) = "List1": SyntaxIndex(c, 3) = 0
                Syntax(c, 4) = "Frames"
                Syntax(c, 5) = "List2": SyntaxIndex(c, 5) = 1
            Case 73 'MapAnimation 'Text' Frames [List] Level [List] At (Context.Var, Context.Var)
                Syntax(c, 0) = "MapAnimation": SyntaxIndex(c, 0) = 7
                Syntax(c, 1) = "Text3": SyntaxIndex(c, 1) = 0
                Syntax(c, 2) = "Frames"
                Syntax(c, 3) = "List1": SyntaxIndex(c, 3) = 2
                Syntax(c, 4) = "Level"
                Syntax(c, 5) = "List2": SyntaxIndex(c, 5) = 5
                Syntax(c, 6) = "At"
                Syntax(c, 7) = "(Var)": SyntaxIndex(c, 7) = 0
            Case 74 'MapRefresh
                Syntax(c, 0) = "MapRefresh": SyntaxIndex(c, 0) = 0
        End Select
    Next c
End Sub
