Attribute VB_Name = "modDT"
Option Explicit

Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Public Const bdDlgNoReply As Integer = 0
Public Const bdDlgWithReply As Integer = 1
Public Const bdDlgItemList As Integer = 2
Public Const bdDlgWithDice As Integer = 3
Public Const bdDlgReplyText As Integer = 4
Public Const bdDlgItem As Integer = 6
Public Const bdDlgSave As Integer = 7
Public Const bdDlgCreatureList As Integer = 8
Public Const bdDlgDebug As Integer = 9
Public Const bdDlgCredits As Integer = 10
Public Const bdSellStyleInv As Integer = 0
Public Const bdSellStyleEnc As Integer = 1

' Grid data type is only used in the combat grid.
Type Grid
    Ref As Creature
    Target As Creature
End Type

'The GetPrivateProfileString function retrieves a string from the
'specified section in an initialization file. This function is provided
'for compatibility with 16-bit Windows-based applications. New applications
'should store initialization information in the registry.
'
'DWORD GetPrivateProfileString(
'    LCreatureWithTurnTSTR  lpszSection,   // address of section name
'    LCreatureWithTurnTSTR  lpszKey,   // address of key name
'    LCreatureWithTurnTSTR  lpszDefault,   // address of default string
'    LPTSTR  lpszReturnBuffer,   // address of destination buffer
'    DWORD  cchReturnBuffer, // size of destination buffer
'    LCreatureWithTurnTSTR  lpszFile   // address of initialization filename
'   );
'Parameters
'
'lpszSection
'Points to a null-terminated string that specifies the section containing
'the key name. If this parameter is NULL, the GetPrivateProfileString function
'copies all section names in the file to the supplied buffer.
'
'lpszKey
'Points to the null-terminated string containing the key name whose associated
'string is to be retrieved. If this parameter is NULL, all key names in the
'section specified by the lpszSection parameter are copied to the buffer
'specified by the lpszReturnBuffer parameter.
'
'lpszDefault
'Points to a null-terminated string that specifies the default value for the
'given key if the key cannot be found in the initialization file. This
'parameter cannot be NULL.
'
'lpszReturnBuffer
'Points to the buffer that receives the retrieved string.
'
'cchReturnBuffer
'Specifies the size, in characters, of the buffer pointed to by the
'lpszReturnBuffer parameter.
'
'lpszFile
'Points to a null-terminated string that names the initialization file. If
'this parameter does not contain a full path to the file, Windows searches
'for the file in the Windows directory.

Public Sub PlayClickMenu()
    Dim rc As Long
    If GlobalMouseClick = 1 Then
        rc = sndPlaySound(App.Path & "\data\interface\" & GlobalInterfaceName & "\click2.wav", &H1)
    End If
End Sub

Public Sub PlayClick()
    Dim rc As Long
    If GlobalMouseClick = 1 Then
        rc = sndPlaySound(App.Path & "\data\interface\" & GlobalInterfaceName & "\click1.wav", &H1)
    End If
End Sub

Public Sub PlayClickDrop()
    Dim rc As Long
    If GlobalMouseClick = 1 Then
        rc = sndPlaySound(App.Path & "\data\interface\" & GlobalInterfaceName & "\click4.wav", &H1)
    End If
End Sub

Public Sub PlayClickLow()
    Dim rc As Long
    If GlobalMouseClick = 1 Then
        rc = sndPlaySound(App.Path & "\data\interface\" & GlobalInterfaceName & "\click3.wav", &H1)
    End If
End Sub

Public Sub PlayClickPass()
    Dim rc As Long
    If GlobalWAVState = 1 Then
        rc = sndPlaySound(App.Path & "\data\stock\pass.wav", &H1)
    End If
End Sub

Public Sub PlayClickCast()
    Dim rc As Long, PauseUntil As Single
    If GlobalWAVState = 1 Then
        PauseUntil = Timer + 5
        Do Until rc = 1 Or Timer > PauseUntil
            rc = sndPlaySound(App.Path & "\data\stock\cast.wav", &H10)
        Loop
    End If
End Sub

Public Sub PlayMusic(ByVal SongName As String, Optional AlternatePath As Variant)
    Dim c As Integer, FileName As String
    On Error GoTo ErrorHandler
    ' Fade out song
'    c = mciSendString("close songnow", 0&, 0, 0)
    ' Fade in here
    ' Find location of Song
    FileName = Dir(App.Path & "\data\music\" & SongName)
    If FileName = "" Then
        FileName = Dir(App.Path & "\data\music\combat\" & SongName)
        If FileName = "" Then
            FileName = Dir(App.Path & "\data\music\adventure\" & SongName)
            If FileName = "" And IsMissing(AlternatePath) = False Then
                FileName = Dir(AlternatePath & "\" & SongName)
                If FileName = "" Then
                    Exit Sub
                Else
                    ChDir AlternatePath
                End If
            Else
                ChDir App.Path & "\data\music\adventure"
            End If
        Else
            ChDir App.Path & "\data\music\combat"
        End If
    Else
        ChDir App.Path & "\data\music"
    End If
    ' Play MID with Windows Media Player
    frmMain.MediaPlayerMusic.FileName = SongName
    frmMain.MediaPlayerMusic.Play

ErrorHandler:
    Resume Next
'    c = mciSendString("open " & SongName & " type sequencer alias songnow", 0&, 0, 0)
'    c = mciSendString("play songnow", 0&, 0, 0)
'
'    Dim RetMidi As Long
'    Dim RetString As String
'    Dim CallBack As Long
'
'    Dim Length As Single
'    Dim PercentDone As Single
'    Dim Restart
'
'    RetString = Space$(128)
'    RetMidi = mciSendString("status midi length", RetString, 128, CallBack)
'    If Val(RetString) Then
'        Length = Val(RetString)
'        RetMidi = mciSendString("status midi position", RetString, 128, CallBack)
'        PercentDone = Val(RetString) / Length
'
'        If PercentDone >= 1 Then
'            tmrCheckMusic.Enabled = False
'            Call Music_Play(CurrentMIDI)
'            Exit Sub
'        End If
'    Else
'        Exit Sub
'    End If

End Sub

Sub PlaySound(ByVal SoundName As String, Wait As Integer)
    Dim rc As Long, PauseUntil As Single, FileName As String
    On Error GoTo ErrorHandler
    ' If Sound Effects are off, then play nothing
    If GlobalWAVState = 0 Then
        Exit Sub
    End If
    ' If not ending in .wav, then do that now
    If Right(LCase(SoundName), 4) <> ".wav" Then
        SoundName = SoundName & ".wav"
    End If
    ' Find location of Song
    FileName = Dir(App.Path & "\data\sounds\" & SoundName)
    If FileName = "" Then
        FileName = Dir(frmMain.Tome.FullPath & "\" & SoundName)
        If FileName = "" Then
            Exit Sub
        Else
            FileName = frmMain.Tome.FullPath & "\" & SoundName
        End If
    Else
        FileName = App.Path & "\data\sounds\" & SoundName
    End If
    ' Play the Sound file
    'SND_SYNC      = &H00 Program loses control until the sound ends
    'SND_ASYN      = &H01 Program gets back control.
    'SND_NODEFAULT = &H02 Don't beep if can't find sound.
    'SND_LOOP      = &H08 Play until called again with WaveFile = ""
    'SND_NOSTOP    = &H10 If sound is already playing, return false and don't play.
    If Wait Then
        PauseUntil = Timer + 5
        Do Until rc = 1 Or Timer > PauseUntil
            rc = sndPlaySound(FileName, &H10)
        Loop
    Else
        rc = sndPlaySound(FileName, &H1)
    End If
    
ErrorHandler:
    Resume Next
End Sub

Public Function OpName(ByVal Index As Integer) As String
    Select Case Index
        Case 0  ' =
            OpName = "EqualTo"
        Case 1  ' +
            OpName = "Plus"
        Case 2  ' -
            OpName = "Minus"
        Case 3  ' *
            OpName = "X"
        Case 4  ' /
            OpName = "DividedBy"
        Case 5  ' >
            OpName = "GreaterThan"
        Case 6  ' <
            OpName = "LessThan"
        Case 7  ' >=
            OpName = "GreaterOrEqual"
        Case 8  ' <=
            OpName = "LessOrEqual"
        Case 9  ' Or
            OpName = "Or"
        Case 10 ' And
            OpName = "And"
        Case 11 ' Xor
            OpName = "XOr"
        Case 12 ' Like
            OpName = "Like"
    End Select

End Function

