VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "EntryPoint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Version number for Class
Dim myVersion As Integer
' Unique number for this Entry Point
Dim myIndex As Integer
' Name of Entry Point
Dim myName As String
' Description when enter/exit from this Entry Point
Dim myDescription As String
' X coordinate where entry point is located on this Map
Dim myMapX As Integer
' Y coordinate where entry point is located on this Map
Dim myMapY As Integer
' Bit1-4 (Style)
'       0 - Exit
'       1 - Exit Up
'       2 - Exit Down
'       3 - No Show Exit Sign
' Bit5-8 (MapStyle)
'       0 - To Town Map
'       1 - To Wilderness Map
'       2 - To Building Map
'       3 - To Dungeon Map
' Bit9  -   On=InUse with TomeWizard, Off=Not used
' Bit10 -   On=No Show Exit Sign, Off=Show Exit Sign
' Bit11-16   - Undefined
Dim myFlags As Integer

' Index of Area (.rsa file) to jump to when hit this entry point. 0 is Main Menu. -1 is Random.
Dim myAreaIndex As Integer
' Index of Map within above Area to jump to.
Dim myMapIndex As Integer
' Index of EntryPoint within above Map.
Dim myEntryIndex As Integer

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewValue As Integer)
    myIndex = NewValue
End Property

Public Property Get Name() As String
    Name = Trim(myName)
End Property

Public Property Let Name(NewValue As String)
    myName = Trim(NewValue)
End Property

Public Property Get Description() As String
    Description = Trim(myDescription)
End Property

Public Property Let Description(NewValue As String)
    myDescription = Trim(NewValue)
End Property

Public Property Get MapX() As Integer
    MapX = myMapX
End Property

Public Property Let MapX(NewValue As Integer)
    myMapX = NewValue
End Property

Public Property Get MapY() As Integer
    MapY = myMapY
End Property

Public Property Let MapY(NewValue As Integer)
    myMapY = NewValue
End Property

Public Property Get Style() As Integer
    Style = CInt(myFlags And &HF)
End Property

Public Property Let Style(NewValue As Integer)
    myFlags = myFlags And &HFFF0
    myFlags = myFlags Or (NewValue And &HF)
End Property

Public Property Get ToStyle() As Integer
    Select Case Me.Style
        Case 0  ' Exit
            ToStyle = 0
        Case 1  ' Exit Up
            ToStyle = 2
        Case 2  ' Exit Down
            ToStyle = 1
    End Select
End Property

Public Property Get MapStyle() As Integer
    MapStyle = CInt((myFlags And &HF0) / 16)
End Property

Public Property Let MapStyle(NewValue As Integer)
    myFlags = myFlags And &HFF0F
    myFlags = myFlags Or (NewValue * 16 And &HF0)
End Property

Public Property Get IsUsed() As Integer
    IsUsed = (myFlags And &H100) > 0
End Property

Public Property Let IsUsed(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H100
    Else
        myFlags = myFlags And (Not &H100)
    End If
End Property

Public Property Get IsNoExitSign() As Integer
    IsNoExitSign = (myFlags And &H200) > 0
End Property

Public Property Let IsNoExitSign(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H200
    Else
        myFlags = myFlags And (Not &H200)
    End If
End Property

Public Property Get Flags() As Integer
    Flags = myFlags
End Property

Public Property Let Flags(NewValue As Integer)
    myFlags = NewValue
End Property

Public Property Get AreaIndex() As Integer
    AreaIndex = myAreaIndex
End Property

Public Property Let AreaIndex(NewValue As Integer)
    myAreaIndex = NewValue
End Property

Public Property Get MapIndex() As Integer
    MapIndex = myMapIndex
End Property

Public Property Let MapIndex(NewValue As Integer)
    myMapIndex = NewValue
End Property

Public Property Get EntryIndex() As Integer
    EntryIndex = myEntryIndex
End Property

Public Property Let EntryIndex(NewValue As Integer)
    myEntryIndex = NewValue
End Property

Public Sub Copy(FromEntryPoint As EntryPoint)
    myName = FromEntryPoint.Name
    myDescription = FromEntryPoint.Description
    myMapX = FromEntryPoint.MapX
    myMapY = FromEntryPoint.MapY
    myFlags = FromEntryPoint.Flags
    myAreaIndex = FromEntryPoint.AreaIndex
    myMapIndex = FromEntryPoint.MapIndex
    myEntryIndex = FromEntryPoint.EntryIndex
End Sub

Public Sub SaveToFile(ToFile As Integer)
    Put ToFile, , myVersion
    Put ToFile, , myIndex
    Put ToFile, , Len(myName)
    Put ToFile, , myName
    Put ToFile, , Len(myDescription)
    Put ToFile, , myDescription
    Put ToFile, , myMapX
    Put ToFile, , myMapY
    Put ToFile, , myFlags
    Put ToFile, , myAreaIndex
    Put ToFile, , myMapIndex
    Put ToFile, , myEntryIndex
End Sub

Public Sub ReadFromFile(FromFile As Integer)
    Dim Cnt As Long, c As Integer
    Get FromFile, , myVersion
    Get FromFile, , myIndex
    Get FromFile, , Cnt
    myName = ""
    For c = 1 To Cnt
        myName = myName & " "
    Next c
    Get FromFile, , myName
    Get FromFile, , Cnt
    myDescription = ""
    For c = 1 To Cnt
        myDescription = myDescription & " "
    Next c
    Get FromFile, , myDescription
    Get FromFile, , myMapX
    Get FromFile, , myMapY
    Get FromFile, , myFlags
    Get FromFile, , myAreaIndex
    Get FromFile, , myMapIndex
    Get FromFile, , myEntryIndex
End Sub
