Attribute VB_Name = "modEvents"
Option Explicit
Private FrameNow As TriggerFrame
Const bdIfSkip As Integer = -1
Const bdIfProcess As Integer = 0
Const bdIfEnd As Integer = 1

Public Function FireTrigger(ParentX As Object, TrigToFire As Trigger) As Integer
    Static PgmStack As New Collection
    Dim CreatureX As Creature, CreatureY As Creature, ItemX As Item, ItemY As Item, EncounterX As Encounter
    Dim ThemeX As Theme, TriggerX As Trigger, TileX As Tile
    Dim AreaX As Area, MapX As Map
    Dim c As Integer, i As Integer, ReplyTxt As String, RefreshMap As Integer, x As Integer, y As Integer
    Dim sText As String, Found As Integer
    Dim FrameX As TriggerFrame, StmtX As Statement, FactoidX As Factoid, JournalX As Journal
    Dim ObjectX As Object, ObjectY As Object
    Dim t1 As Single, t2 As Single, Width As Integer, Height As Integer, Cells As Integer
    Dim rc As Integer
    ' Add TriggerName to Debug
    If GlobalDebugMode = 1 Then
        frmMain.DebugHeader = modBD.TriggerName(TrigToFire.TriggerType) & " * " & TrigToFire.Name
    End If
    ' If no statements, then return
    If TrigToFire.Statements.Count = 0 Then
        FireTrigger = True
        Exit Function
    End If
    ' Put new Trigger on stack
    c = 1
    For Each FrameX In PgmStack
        If FrameX.Index >= c Then
            c = FrameX.Index + 1
        End If
    Next FrameX
    Set FrameX = New TriggerFrame
    Set FrameX.Trigger = TrigToFire
    FrameX.Index = c
    PgmStack.Add Item:=FrameX, Key:="T" & FrameX.Index
    ' Expose to other functions in this module
    Set FrameNow = FrameX
    ' Set default values in Frame
    Set FrameX.ParentX = ParentX
    Set FrameX.EncounterX(0) = frmMain.EncounterNow
    If frmMain.Map.EncPointer(frmMain.Tome.MoveToX, frmMain.Tome.MoveToY) > 0 Then
        Set FrameX.EncounterX(4) = frmMain.Map.Encounters("E" & frmMain.Map.EncPointer(frmMain.Tome.MoveToX, frmMain.Tome.MoveToY))
    Else
        Set FrameX.EncounterX(4) = frmMain.EncounterNow
    End If
    Set FrameX.CreatureX(0) = frmMain.CreatureNow
    Set FrameX.CreatureX(4) = frmMain.CreatureTarget
    Set FrameX.ItemX(0) = frmMain.ItemNow
    Set FrameX.ItemX(4) = frmMain.ItemTarget
    Set FrameX.TriggerX(0) = FrameX.Trigger
    Set FrameX.TriggerX(4) = FrameX.Trigger
    FrameX.TileX(0) = frmMain.Tome.MapX
    FrameX.TileY(0) = frmMain.Tome.MapY
    FrameX.TileX(4) = frmMain.Tome.MoveToX
    FrameX.TileY(4) = frmMain.Tome.MoveToY
    ' Set GlobalSkillLevel (if this is a Skill Trigger)
    If FrameX.Trigger.IsSkill = True Then
        If FrameX.Trigger.SkillPoints > 0 And FrameX.Trigger.Turns > 0 Then
            frmMain.GlobalSkillLevel = Int(FrameX.Trigger.SkillPoints / FrameX.Trigger.Turns)
        Else
            frmMain.GlobalSkillLevel = 1
        End If
    End If
    ' Process statements
    With FrameX
        Do Until .StopExit
            .Ticks = .Ticks + 1
            Set StmtX = .Trigger.Statements(.StatementNow)
            sText = ReplaceText(StmtX.Text)
            ' Reset FrameNow just in case some other Trigger fired
            Set FrameNow = FrameX
            ' Pre-Process Statements
            .Process = True
            ' PROBLEM: Nested If Statements. They SHOULD NOT process anything until it
            ' hits an Else, And, Or or EndIf of the same LEVEL OF DEPTH. Currently, it
            ' considers statements (and processes them) even if the current IF failed.
            ' It has something to do with a Select statement "turning on" the logic
            ' to process statements again.
            Select Case StmtX.Statement
                Case 2, 14, 66 ' If, Select, IfText
                    If .IfStackTop < 15 Then
                        .IfStackTop = .IfStackTop + 1
                        .IfStack(.IfStackTop) = bdIfProcess
                    Else
                        .Process = False
                        .Abort = True
                        .StopExit = True
                    End If
                Case 15 ' Case
                    If .IfStackTop > 0 Then
                        Select Case .IfStack(.IfStackTop)
                            Case bdIfProcess
                                .IfStack(.IfStackTop) = bdIfEnd
                            Case bdIfSkip
                                .IfStack(.IfStackTop) = bdIfProcess
                        End Select
                    End If
                Case 3, 4, 6 ' Else, ElseIf, Or
                    If .IfStackTop > 0 Then
                        Select Case .IfStack(.IfStackTop)
                            Case bdIfProcess
                                .IfStack(.IfStackTop) = bdIfEnd
                                .Process = False
                            Case bdIfSkip
                                .IfStack(.IfStackTop) = bdIfProcess
                            Case bdIfEnd
                                .Process = False
                        End Select
                    End If
                Case 7, 16 ' EndIf, EndSelect
                    If .IfStackTop > 0 Then
                        .IfStackTop = .IfStackTop - 1
                    End If
                Case 10 ' Next
                    If .LoopStackTop > 0 Then
                        ' And we have a statement to go back to
                        If .LoopStack(.LoopStackTop) > 0 Then
                            ' Go to the statement pointed to by the stack
                            .StatementNow = .LoopStack(.LoopStackTop)
                            Set StmtX = .Trigger.Statements(.StatementNow)
                        Else
                            .LoopStackTop = .LoopStackTop - 1
                        End If
                    End If
                Case Else
                    ' If inside an If loop and failed check, then skip ahead
                    If .LoopStackTop > 0 Then
                        .Process = (.LoopStack(.LoopStackTop) > 0)
                    End If
                    If .IfStackTop > 0 Then
                        For c = .IfStackTop To 1 Step -1
                            If .IfStack(c) <> bdIfProcess Then
                                .Process = False
                                Exit For
                            End If
                        Next c
                    End If
            End Select
            ' Process Statements
            If .Process Then
                ' Add Statement to DebugQue
                If GlobalDebugMode = 1 Then
                    frmMain.DebugAdd .Trigger, StmtX
                End If
                Select Case StmtX.Statement
                    Case 0  ' <None>
                        ' Do Nothing
                    Case 1  ' Label
                        ' Do Nothing
                    Case 2, 4, 5, 6 ' If, ElseIf, And, Or
                        If CompareVars(StmtX.B(0), StmtX.B(1), StmtX.B(2), StmtX.B(3), StmtX.B(4)) > 0 Then
                            .IfStack(.IfStackTop) = bdIfProcess
                        Else
                            .IfStack(.IfStackTop) = bdIfSkip
                        End If
                    Case 3  ' Else
                        ' Do Nothing
                    Case 7  ' End If
                        ' Do Nothing
                    Case 8  ' While
                        If .LoopStack(.LoopStackTop) <> .StatementNow Then
                            If .LoopStackTop < 15 Then
                                .LoopStackTop = .LoopStackTop + 1
                                .LoopStack(.LoopStackTop) = .StatementNow
                            Else
                                .Abort = True
                                .StopExit = True
                            End If
                        End If
                        If CompareVars(StmtX.B(0), StmtX.B(1), StmtX.B(2), StmtX.B(3), StmtX.B(4)) < 1 Then
                            .LoopStack(.LoopStackTop) = 0
                        End If
                    Case 9  ' ForEach Object In Object.Collection
                        ' If this ForEach not on the Stack, put it there
                        If .LoopStack(.LoopStackTop) <> .StatementNow Then
                            If .LoopStackTop < 15 Then
                                .LoopStackTop = .LoopStackTop + 1
                                .LoopStack(.LoopStackTop) = .StatementNow
                                .EachStack(.LoopStackTop) = 0
                            Else
                                ' We're out of stack space, so have to abort Trigger
                                .Abort = True
                                .StopExit = True
                            End If
                        End If
                        ' Find the Collection looping through
                        Select Case StmtX.B(1)
                            Case 0 To 4 ' In Encounter
                                Set ObjectX = .EncounterX(StmtX.B(1))
                            Case 5 To 9 ' In Item
                                Set ObjectX = .ItemX(StmtX.B(1) - 5)
                            Case 10 ' In Tome
                                Set ObjectX = frmMain.Tome
                            Case 11 To 15   ' In Trigger
                                Set ObjectX = .TriggerX(StmtX.B(1) - 11)
                            Case 16 To 20   ' In Creature
                                Set ObjectX = .CreatureX(StmtX.B(1) - 16)
                        End Select
                        ' If first time through, set match
                        If .EachStack(.LoopStackTop) = 0 Then
                            Select Case StmtX.B(0)
                                Case 0 To 2 ' Creatures
                                    If ObjectX.Creatures.Count > 0 Then
                                        .EachStack(.LoopStackTop) = ObjectX.Creatures(1).Index
                                    End If
                                Case 3 To 5 ' Items
                                    If ObjectX.Items.Count > 0 Then
                                        .EachStack(.LoopStackTop) = ObjectX.Items(1).Index
                                    End If
                                Case 6 To 8 ' Triggers
                                    If ObjectX.Triggers.Count > 0 Then
                                        .EachStack(.LoopStackTop) = ObjectX.Triggers(1).Index
                                    End If
                            End Select
                        End If
                        ' Find the matching object
                        Select Case StmtX.B(0)
                            Case 0 To 2 ' Creatures
                                For c = 1 To ObjectX.Creatures.Count
                                    If ObjectX.Creatures(c).Index = .EachStack(.LoopStackTop) Then
                                        Set .CreatureX(StmtX.B(0) + 1) = ObjectX.Creatures(c)
                                        If c < ObjectX.Creatures.Count Then
                                            .EachStack(.LoopStackTop) = ObjectX.Creatures(c + 1).Index
                                        Else
                                            .EachStack(.LoopStackTop) = -1
                                        End If
                                        Exit For
                                    End If
                                Next c
                                If c > ObjectX.Creatures.Count Then
                                    .LoopStack(.LoopStackTop) = 0
                                End If
                            Case 3 To 5 ' Items
                                For c = 1 To ObjectX.Items.Count
                                    If ObjectX.Items(c).Index = .EachStack(.LoopStackTop) Then
                                        Set .ItemX(StmtX.B(0) - 2) = ObjectX.Items(c)
                                        If c < ObjectX.Items.Count Then
                                            .EachStack(.LoopStackTop) = ObjectX.Items(c + 1).Index
                                        Else
                                            .EachStack(.LoopStackTop) = -1
                                        End If
                                        Exit For
                                    End If
                                Next c
                                If c > ObjectX.Items.Count Then
                                    .LoopStack(.LoopStackTop) = 0
                                End If
                            Case 6 To 8 ' Triggers
                                For c = 1 To ObjectX.Triggers.Count
                                    If ObjectX.Triggers(c).Index = .EachStack(.LoopStackTop) Then
                                        Set .TriggerX(StmtX.B(0) - 5) = ObjectX.Triggers(c)
                                        If c < ObjectX.Triggers.Count Then
                                            .EachStack(.LoopStackTop) = ObjectX.Triggers(c + 1).Index
                                        Else
                                            .EachStack(.LoopStackTop) = -1
                                        End If
                                        Exit For
                                    End If
                                Next c
                                If c > ObjectX.Triggers.Count Then
                                    .LoopStack(.LoopStackTop) = 0
                                End If
                        End Select
                    Case 10 ' Next
                        ' Do Nothing
                    Case 11 ' Branch
                        ' Loop and find the matching Label
                        For c = 1 To .Trigger.Statements.Count
                            ' Find a Label statement
                            If .Trigger.Statements(c).Statement = 1 Then
                                ' If match, then branch there
                                If CompareVars(.Trigger.Statements(c).B(0), .Trigger.Statements(c).B(1), 0, StmtX.B(0), StmtX.B(1)) > 0 Then
                                    .StatementNow = c - 1
                                    Exit For
                                End If
                            End If
                        Next c
                    Case 12 ' Put
                        PutVarContext StmtX.B(5), StmtX.B(6), _
                            CompareVars(StmtX.B(0), StmtX.B(1), _
                            StmtX.B(2), StmtX.B(3), StmtX.B(4))
                    Case 13 ' Set
                        Select Case StmtX.B(0)
                            Case 0  ' CreatureNow
                                Set .CreatureX(StmtX.B(0)) = .CreatureX(StmtX.B(1))
                                Set frmMain.CreatureNow = .CreatureX(StmtX.B(1))
                            Case 1 To 3 ' CreatureA, B, C
                                Set .CreatureX(StmtX.B(0)) = .CreatureX(StmtX.B(1))
                            Case 4  ' CreatureTarget
                                Set .CreatureX(StmtX.B(0)) = .CreatureX(StmtX.B(1))
                                Set frmMain.CreatureTarget = .CreatureX(StmtX.B(1))
                            Case 5 To 9 ' EncounterNow, A, B, C, Target
                                Set .EncounterX(StmtX.B(0) - 5) = .EncounterX(StmtX.B(1))
                            Case 10 ' ItemTarget
                                Set .ItemX(StmtX.B(0) - 10) = .ItemX(StmtX.B(1))
                                Set frmMain.ItemTarget = .ItemX(StmtX.B(1))
                            Case 11 To 13 ' ItemA, B, C
                                Set .ItemX(StmtX.B(0) - 10) = .ItemX(StmtX.B(1))
                            Case 14 ' ItemNow
                                Set .ItemX(StmtX.B(0) - 10) = .ItemX(StmtX.B(1))
                                Set frmMain.ItemNow = .ItemX(StmtX.B(1))
                            Case 15 To 19   ' TileNow, TileA, B, C, TileTarget
                                .TileX(StmtX.B(0) - 15) = .TileX(StmtX.B(1))
                                .TileY(StmtX.B(0) - 15) = .TileY(StmtX.B(1))
                            Case 20 To 24   ' TriggerNow, A, B, C, TriggerTarget
                                Set .TriggerX(StmtX.B(0) - 20) = .TriggerX(StmtX.B(1))
                        End Select
                    Case 14 ' Select
                        If IsNumeric(GetVarContext(StmtX.B(0), StmtX.B(1))) Then
                            .CaseStack(.IfStackTop) = GetVarContext(StmtX.B(0), StmtX.B(1))
                        Else
                            .CaseStack(.IfStackTop) = 0
                        End If
                    Case 15 ' Case
                        If GetVarContext(StmtX.B(0), StmtX.B(1)) = .CaseStack(.IfStackTop) Then
                            .IfStack(.IfStackTop) = bdIfProcess
                        Else
                            .IfStack(.IfStackTop) = bdIfSkip
                        End If
                    Case 16 ' EndSelect
                        ' Do Nothing
                    Case 17 ' Exit
                        Select Case StmtX.B(0)
                            Case 0  ' Trigger
                                .StopExit = True
                            Case 1  ' Loop
                                .LoopStack(.LoopStackTop) = 0
                            Case 2  ' Abort
                                .StopExit = True
                                .Abort = True
                        End Select
                    Case 18 ' CopyCreature
                        ' Indicates if copied to Encounter or Party
                        Found = False
                        ' Copy To
                        Select Case StmtX.B(1)
                            Case 0 To 4 ' Encounter
                                Set ObjectX = .EncounterX(StmtX.B(1)).AddCreature
                                Found = True
                            Case 5      ' Party
                                Set ObjectX = frmMain.Tome.AddCreature
                                Found = True
                            Case 6 To 10    ' Trigger
                                Set ObjectX = .TriggerX(StmtX.B(1) - 6).AddCreature
                        End Select
                        For Each CreatureX In .Trigger.Creatures
                            If CreatureX.Index = StmtX.B(0) Then
                                ObjectX.Copy .Trigger.Creatures("X" & StmtX.B(0))
                                frmMain.LoadCreaturePic ObjectX
                                Exit For
                            End If
                        Next CreatureX
                        If Found = True Then
                            If frmMain.picGrid.Visible = True Then
                                frmMain.CombatArrays
                                frmMain.CombatDraw
                            Else
                                Select Case StmtX.B(1)
                                    Case 0 To 4
                                        modDungeonMaker.PositionCreature frmMain.Map, .EncounterX(StmtX.B(1)), ObjectX
                                    Case 5
                                        frmMain.MenuDrawParty
                                End Select
                            End If
                        End If
                    Case 19 ' CopyItem
                        Select Case StmtX.B(1)
                            Case 0 To 4
                                Set ObjectX = .CreatureX(StmtX.B(1)).AddItem
                            Case 5 To 9
                                Set ObjectX = .EncounterX(StmtX.B(1) - 5).AddItem
                            Case 10 To 14
                                Set ObjectX = .ItemX(StmtX.B(1) - 10).AddItem
                            Case 15 To 19
                                Set ObjectX = .TriggerX(StmtX.B(1) - 15).AddItem
                        End Select
                        For Each ItemX In .Trigger.Items
                            If ItemX.Index = StmtX.B(0) Then
                                ObjectX.Copy .Trigger.Items("I" & StmtX.B(0))
                                ObjectX.IsReady = False
                                frmMain.LoadItemPic ObjectX
                            End If
                        Next ItemX
                    Case 20 ' CopyTrigger
                        Select Case StmtX.B(1)
                            Case 0 To 4
                                Set ObjectX = .CreatureX(StmtX.B(1)).AddTrigger
                            Case 5 To 9
                                Set ObjectX = .EncounterX(StmtX.B(1) - 5).AddTrigger
                            Case 10 To 14
                                Set ObjectX = .ItemX(StmtX.B(1) - 10).AddTrigger
                            Case 15
                                Set ObjectX = frmMain.Tome.AddTrigger
                            Case 16 To 20
                                Set ObjectX = .TriggerX(StmtX.B(1) - 16).AddTrigger
                        End Select
                        For Each TriggerX In .Trigger.Triggers
                            If TriggerX.Index = StmtX.B(0) Then
                                ObjectX.Copy .Trigger.Triggers("T" & StmtX.B(0))
                                Exit For
                            End If
                        Next TriggerX
                    Case 21 ' CopyTile
                        ' Validate X, Y coordinate
                        x = GetVarContext(StmtX.B(0), StmtX.B(1))
                        y = GetVarContext(StmtX.B(3), StmtX.B(4))
                        If PointIn(x, y, 0, 0, frmMain.Map.Width, frmMain.Map.Height) Then
                            ' Locate Tile Name in Current Map
                            For Each TileX In frmMain.Map.Tiles
                                If TileX.Name = sText Then
                                    Select Case StmtX.B(2)
                                        Case 0  ' Bottom
                                            frmMain.Map.BottomTile(x, y) = TileX.Index
                                            frmMain.Map.BottomFlip(x, y) = False
                                        Case 1  ' Bottom (Flip)
                                            frmMain.Map.BottomTile(x, y) = TileX.Index
                                            frmMain.Map.BottomFlip(x, y) = True
                                        Case 2  ' Middle
                                            frmMain.Map.MiddleTile(x, y) = TileX.Index
                                            frmMain.Map.MiddleFlip(x, y) = False
                                        Case 3  ' Middle (Flip)
                                            frmMain.Map.MiddleTile(x, y) = TileX.Index
                                            frmMain.Map.MiddleFlip(x, y) = True
                                        Case 4  ' Top
                                            frmMain.Map.TopTile(x, y) = TileX.Index
                                            frmMain.Map.TopFlip(x, y) = False
                                        Case 5  ' Top (Flip)
                                            frmMain.Map.TopTile(x, y) = TileX.Index
                                            frmMain.Map.TopFlip(x, y) = True
                                    End Select
                                    RefreshMap = True
                                    Exit For
                                End If
                            Next TileX
                        End If
                    Case 22 ' CopyText
                        PutVarContext StmtX.B(0), StmtX.B(1), sText
                    Case 23 ' Runes
                        ' Do Nothing
                    Case 24 ' AddFactoid
                        Set FactoidX = frmMain.Tome.AddFactoid
                        FactoidX.Text = sText
                    Case 25 ' AddJournalEntry
                        frmMain.Tome.AddJournal.Text = sText
                        If frmMain.picJournal.Visible = True And frmMain.JournalMode = 0 Then
                            frmMain.JournalEntryLoad
                            frmMain.JournalShow
                        End If
                    Case 26 ' Destroy
                        ' Indicates if destroying in Party or Encounters
                        Found = False
                        ' Object contained in
                        Select Case StmtX.B(1)
                            Case 0 To 4
                                Set ObjectX = .EncounterX(StmtX.B(1))
                                Found = True
                            Case 5 To 9
                                Set ObjectX = .ItemX(StmtX.B(1) - 5)
                            Case 10
                                Set ObjectX = frmMain.Tome
                                Found = True
                            Case 11 To 15
                                Set ObjectX = .TriggerX(StmtX.B(1) - 11)
                            Case 16 To 20
                                Set ObjectX = .CreatureX(StmtX.B(1) - 16)
                        End Select
                        ' Object to destroy
                        Select Case StmtX.B(0)
                            Case 0 To 2, 9, 10 ' Creature
                                If StmtX.B(0) = 9 Then
                                    c = 0
                                ElseIf StmtX.B(0) = 10 Then
                                    c = 4
                                Else
                                    c = StmtX.B(0) + 1
                                End If
                                For Each CreatureX In ObjectX.Creatures
                                    If CreatureX.Index = .CreatureX(c).Index Then
                                        ObjectX.RemoveCreature "X" & .CreatureX(c).Index
                                        Exit For
                                    End If
                                Next CreatureX
                                If Found = True Then
                                    ' If combat is active, reset the combat creatures
                                    If frmMain.picGrid.Visible = True Then
                                        frmMain.CombatArrays
                                        frmMain.CombatDraw
                                    ElseIf StmtX.B(1) = 10 Then
                                        ' If destroying from Party, redraw the Party
                                        frmMain.MenuDrawParty
                                    End If
                                End If
                            Case 3 To 5, 11, 12 ' Item
                                If StmtX.B(0) = 11 Then
                                    c = 0
                                ElseIf StmtX.B(0) = 12 Then
                                    c = 4
                                Else
                                    c = StmtX.B(0) - 2
                                End If
                                For Each ItemX In ObjectX.Items
                                    If ItemX.Index = .ItemX(c).Index Then
                                        ObjectX.RemoveItem "I" & .ItemX(c).Index
                                        Exit For
                                    End If
                                Next ItemX
                            Case 6 To 8, 13, 14 ' Trigger
                                If StmtX.B(0) = 13 Then
                                    c = 0
                                ElseIf StmtX.B(0) = 14 Then
                                    c = 4
                                Else
                                    c = StmtX.B(0) - 5
                                End If
                                For Each TriggerX In ObjectX.Triggers
                                    If TriggerX.Index = .TriggerX(c).Index Then
                                        ObjectX.RemoveTrigger "T" & .TriggerX(c).Index
                                        Exit For
                                    End If
                                Next TriggerX
                        End Select
                    Case 27 ' CombatApplyDamage
                        frmMain.CombatApplyDamage .CreatureX(StmtX.B(0)), GetVarContext(StmtX.B(3), StmtX.B(4))
                    Case 28 ' CombatRollAttack
                        c = frmMain.CombatRollAttack(StmtX.B(5), GetVarContext(StmtX.B(0), StmtX.B(1)))
                        If c = False Then
                            .Fail = 1
                        End If
                    Case 29 ' CombatRollDamage
                        c = frmMain.CombatRollDamage(StmtX.B(0), StmtX.B(1), StmtX.B(5), (StmtX.B(2) > 0), 0)
                        .Fail = c
                    Case 30 ' DestroyFactoid
                        For Each FactoidX In frmMain.Tome.Factoids
                            If InStr(UCase(FactoidX.Text), UCase(sText)) > 0 Then
                                frmMain.Tome.RemoveFactoid "F" & FactoidX.Index
                            End If
                        Next FactoidX
                    Case 31 ' TargetCreature
                        ' Target Creature into CreatureX (within Range)
                        Set CreatureX = New Creature
                        If IsNumeric(GetVarContext(StmtX.B(3), StmtX.B(4))) = True Then
                            If frmMain.TargetCreature(CreatureX, GetVarContext(StmtX.B(3), StmtX.B(4)), StmtX.B(1), StmtX.B(2)) = False Then
                                .StopExit = True
                                .Abort = True
                            End If
                        Else
                            If frmMain.TargetCreature(CreatureX, 11, StmtX.B(1), StmtX.B(2)) = False Then
                                .StopExit = True
                                .Abort = True
                            End If
                        End If
                        Set .CreatureX(StmtX.B(0) + 1) = CreatureX
                        If StmtX.B(0) = 3 Then  ' If setting CreatureTarget, then set frmMain
                            Set frmMain.CreatureTarget = CreatureX
                        End If
                    Case 32 ' TargetItem
                        ' Target Item into ItemX Using CreatureWithTurn Inventory or Encounter
                        If frmMain.TargetItem(ItemX) = False Then
                            .StopExit = True
                            .Abort = True
                        End If
                        Set FrameNow = FrameX
                        Set .ItemX(StmtX.B(0) + 1) = ItemX
                    Case 33 ' PlaySound
                        PlaySound StmtX.Text, (StmtX.B(0) > 0)
                    Case 34 ' PlayMusic
                        PlayMusic StmtX.Text, frmMain.Tome.FullPath
                        frmMain.GlobalMusicName = StmtX.Text
                    Case 35 ' MoveParty
                        For Each MapX In frmMain.Area.Plot.Maps
                            If MapX.Index = StmtX.B(5) Then
                                frmMain.TomeStartArea frmMain.Area.Index, MapX.Index, -1, _
                                    GetVarContext(StmtX.B(0), StmtX.B(1)), GetVarContext(StmtX.B(3), StmtX.B(4))
                                Exit For
                            End If
                        Next MapX
                    Case 36 ' DialogShow
                        Select Case StmtX.B(0)
                            Case 0  ' Normal
                                frmMain.DialogSetUp bdDlgNoReply
                                frmMain.DialogShow BreakText(sText, 1), BreakText(sText, 2)
                            Case 1  ' Brief TextBox
                                frmMain.DialogBrief BreakText(sText, 1), BreakText(sText, 2)
                            Case 2  ' Reply WithPick
                                frmMain.DialogSetUp bdDlgWithReply
                                ReplyTxt = sText
                            Case 3  ' Reply WithText
                                frmMain.DialogSetUp bdDlgReplyText
                                ReplyTxt = sText
                            Case 4, 5 ' Brief TextLine
                                frmMain.MessageShow BreakText(sText, 2), 0
                        End Select
                    Case 37 ' DialogReply
                        frmMain.DialogReplyAdd sText
                    Case 38 ' DialogAccept
                        c = frmMain.DialogShow(BreakText(ReplyTxt, 1), BreakText(ReplyTxt, 2)) + 1
                        PutVarContext StmtX.B(0), StmtX.B(1), c
                    Case 39 ' DialogDice
                        frmMain.DialogDice BreakText(StmtX.Text, 1), BreakText(sText, 2), StmtX.B(2), c
                        PutVarContext StmtX.B(0), StmtX.B(1), c
                    Case 40 ' DialogHide
                        frmMain.DialogHide
                    Case 41 ' CutScene
                        frmMain.CutScene StmtX.B(0), BreakText(sText, 1), BreakText(sText, 2)
                        RefreshMap = True
                    Case 42 ' SorceryQueRunes
                        Dim Runes(5) As Byte
                        For c = 0 To 5
                            Runes(c) = StmtX.B(c)
                        Next c
                        c = frmMain.SorceryMatchRunes(.CreatureX(0), Runes(), (StmtX.B(6) = 0))
                        If c <> 0 And .Fail = 0 Then
                            .Fail = 1
                        End If
                    Case 43 ' CombatMove
                        If frmMain.picGrid.Visible = True Then
                            frmMain.CombatMove StmtX.B(0), StmtX.B(1)
                        Else
                            .StopExit = True
                            .Abort = True
                        End If
                    Case 44 ' CombatAttack
                        frmMain.CombatAttack StmtX.B(0), sText, StmtX.B(3), StmtX.B(4)
                    Case 45 ' CombatTarget
                        If frmMain.picGrid.Visible = True Then
                            Set FrameNow.CreatureX(4) = frmMain.CombatTarget(FrameNow.CreatureX(0), StmtX.B(0))
                            Set frmMain.CreatureTarget = FrameNow.CreatureX(4)
                        Else
                            .StopExit = True
                            .Abort = True
                        End If
                    Case 46 ' PlaySFX
                        frmMain.PlaySFX StmtX.Text, StmtX.B(0), StmtX.B(1), StmtX.B(2), StmtX.B(3)
                    Case 47 ' Sorcery
                        If IsNumeric(GetVarContext(StmtX.B(0), StmtX.B(1))) Then
                            frmMain.GlobalSpellFizzleChance = GetVarContext(StmtX.B(0), StmtX.B(1))
                        Else
                            frmMain.GlobalSpellFizzleChance = 0
                        End If
                        ' frmMain.SorceryShow 0
                    Case 48 ' DialogBuySell
                        If IsNumeric(GetVarContext(StmtX.B(0), StmtX.B(1))) Then
                            c = GetVarContext(StmtX.B(0), StmtX.B(1))
                        Else
                            c = 0
                        End If
                        frmMain.DialogBuySell .Trigger, StmtX.B(2), c
                    Case 49 ' Not Used
                    Case 50 ' ExecTrigger
                        If StmtX.B(0) > 0 Then
                            For Each TriggerX In .Trigger.Triggers
                                If TriggerX.Index = StmtX.B(0) Then
                                    .Fail = Not FireTrigger(.Trigger, .Trigger.Triggers("T" & StmtX.B(0)))
                                    Exit For
                                End If
                            Next TriggerX
                        End If
                        ' Reset pointers back to current Trigger
                        Set FrameNow = FrameX
                    Case 51 ' DialogAcceptText
                        c = frmMain.DialogShow(BreakText(ReplyTxt, 1), BreakText(ReplyTxt, 2))
                        ' If no text is entered, then set Local.Fail to True
                        If LenStr(frmMain.DialogText) < 1 Then
                            .Fail = 1
                        End If
                        PutVarContext StmtX.B(0), StmtX.B(1), frmMain.DialogText
                    Case 52 ' CombatStart
                        frmMain.CombatStart
                    Case 53 ' Let
                        PutVarContext StmtX.B(0), StmtX.B(1), GetVarContext(StmtX.B(3), StmtX.B(4))
                    Case 54 ' Comment
                        ' Do nothing
                    Case 55 ' RandomizeEncounter
                        ' Find Encounter matching Name on current Map
                        For Each EncounterX In frmMain.Map.Encounters
                            If InStr(UCase(EncounterX.Name), UCase(sText)) > 0 Then
                                MakeEncounter frmMain.Map, EncounterX
                            End If
                        Next EncounterX
                    Case 56 ' RandomizeTheme
                        For Each ThemeX In frmMain.Map.Themes
                            If InStr(UCase(ThemeX.Name), UCase(sText)) > 0 Then
                                ThemeMap frmMain.Map, ThemeX
                            End If
                        Next ThemeX
                    Case 57 ' AwardExperience
                        If StmtX.B(0) = 0 Then
                            ' Award to the Party
                            frmMain.AwardExperienceToParty GetVarContext(StmtX.B(5), StmtX.B(6))
                        Else
                            ' Award to a single Creature
                            frmMain.AwardExperienceToCreature .CreatureX(StmtX.B(0) - 1), GetVarContext(StmtX.B(5), StmtX.B(6))
                        End If
                    Case 58 ' MoveItem
                        ' From Object
                        Select Case StmtX.B(1)
                            Case 0 To 4     ' CreatureX
                                Set ObjectX = .CreatureX(StmtX.B(1))
                            Case 5 To 9     ' EncounterX
                                Set ObjectX = .EncounterX(StmtX.B(1) - 5)
                            Case 10 To 14   ' ItemX
                                Set ObjectX = .ItemX(StmtX.B(1) - 10)
                            Case 15 To 19   ' TriggerX
                                Set ObjectX = .TriggerX(StmtX.B(1) - 15)
                        End Select
                        ' To Object
                        Select Case StmtX.B(3)
                            Case 0 To 4     ' CreatureX
                                Set ObjectY = .CreatureX(StmtX.B(3))
                            Case 5 To 9     ' EncounterX
                                Set ObjectY = .EncounterX(StmtX.B(3) - 5)
                            Case 10 To 14   ' ItemX
                                Set ObjectY = .ItemX(StmtX.B(3) - 10)
                            Case 15 To 19   ' TriggerX
                                Set ObjectY = .TriggerX(StmtX.B(3) - 15)
                        End Select
                        ' Locate ItemX In ObjectX
                        For Each ItemX In ObjectX.Items
                            If ItemX.Name = .ItemX(StmtX.B(0)).Name And ItemX.Index = .ItemX(StmtX.B(0)).Index Then
                                Set ItemY = ObjectY.AddItem
                                ItemY.Copy ItemX
                                ItemY.IsReady = False
                                If StmtX.B(2) = 0 Then
                                    ObjectX.RemoveItem "I" & ItemX.Index
                                End If
                                Exit For
                            End If
                        Next ItemX
                    Case 59 ' AddQuest
                        frmMain.Tome.AddJournal.Text = "Quest|" & sText
                        If frmMain.JournalMode = 1 And frmMain.picJournal.Visible = True Then
                            frmMain.JournalQuestsLoad
                            frmMain.JournalShow
                        End If
                    Case 60 ' RemoveQuest
                        For Each JournalX In frmMain.Tome.Journals
                            If InStr(UCase(JournalX.Text), UCase(BreakText(sText, 1))) > 0 Then
                                frmMain.Tome.RemoveJournal "J" & JournalX.Index
                            End If
                        Next JournalX
                        If frmMain.JournalMode = 1 And frmMain.picJournal.Visible = True Then
                            frmMain.JournalQuestsLoad
                            frmMain.JournalShow
                        End If
                    Case 61 ' AnnotateMap
                    Case 62 ' CombatAttackWithWeapon
                        frmMain.CombatAttack 62, "", 0, 0
                    Case 63 ' CombatAttackWithSpecial
                        frmMain.CombatAttack 63, sText, StmtX.B(5), StmtX.B(6)
                    Case 64 ' MovePartyMapName
                        ' Find Area in Tome
                        For Each AreaX In frmMain.Tome.Areas
                            If AreaX.Index = StmtX.B(2) Then
                                If AreaX.Index <> frmMain.Area.Index Then
                                    frmMain.TomeStartArea AreaX.Index, 0, -1, GetVarContext(StmtX.B(0), StmtX.B(1)), GetVarContext(StmtX.B(3), StmtX.B(4)), StmtX.Text
                                Else
                                    ' Find Map Name in Area
                                    For Each MapX In frmMain.Area.Plot.Maps
                                        If MapX.Name = StmtX.Text Then
                                            frmMain.TomeStartArea AreaX.Index, MapX.Index, -1, _
                                                GetVarContext(StmtX.B(0), StmtX.B(1)), GetVarContext(StmtX.B(3), StmtX.B(4))
                                        End If
                                    Next MapX
                                    Exit For
                                End If
                            End If
                        Next AreaX
                    Case 65 ' MoveCreature
                        ' Determines if need to refresh EncounterNow or Party
                        Found = False
                        ' From Object
                        Select Case StmtX.B(1)
                            Case 0 To 4     ' CreatureX
                                Set ObjectX = .CreatureX(StmtX.B(1))
                            Case 5 To 9     ' EncounterX
                                Set ObjectX = .EncounterX(StmtX.B(1) - 5)
                                Found = True
                            Case 10 To 14   ' ItemX
                                Set ObjectX = .ItemX(StmtX.B(1) - 10)
                            Case 15 To 19   ' TriggerX
                                Set ObjectX = .TriggerX(StmtX.B(1) - 15)
                            Case 20
                                Set ObjectX = frmMain.Tome
                                Found = True
                        End Select
                        ' To Object
                        Select Case StmtX.B(3)
                            Case 0 To 4     ' CreatureX
                                Set ObjectY = .CreatureX(StmtX.B(3))
                            Case 5 To 9     ' EncounterX
                                Set ObjectY = .EncounterX(StmtX.B(3) - 5)
                                Found = True
                            Case 10 To 14   ' ItemX
                                Set ObjectY = .ItemX(StmtX.B(3) - 10)
                            Case 15 To 19   ' TriggerX
                                Set ObjectY = .TriggerX(StmtX.B(3) - 15)
                            Case 20
                                Set ObjectY = frmMain.Tome
                                Found = True
                        End Select
                        ' Locate CreatureX In ObjectX
                        For Each CreatureX In ObjectX.Creatures
                            If CreatureX.Name = .CreatureX(StmtX.B(0)).Name And CreatureX.Index = .CreatureX(StmtX.B(0)).Index Then
                                Set CreatureY = ObjectY.AddCreature
                                CreatureY.Copy CreatureX
                                CreatureY.Initiative = CreatureX.Initiative
                                CreatureY.Row = CreatureX.Row
                                CreatureY.Col = CreatureX.Col
                                frmMain.LoadCreaturePic CreatureY
                                If StmtX.B(2) = 0 Then
                                    ObjectX.RemoveCreature "X" & CreatureX.Index
                                End If
                                Exit For
                            End If
                        Next CreatureX
                        ' Reset combat screen if move to/from Encounter or Party
                        If Found = True Then
                            ' If combat is active, reset the combat creatures
                            If frmMain.picGrid.Visible = True Then
                                frmMain.CombatArrays
                                frmMain.CombatDraw
                            Else
                                ' If moving to Encounters, position the Creature
                                Select Case StmtX.B(3)
                                    Case 5 To 9 ' Encounters
                                        modDungeonMaker.PositionCreature frmMain.Map, ObjectY, CreatureY
                                End Select
                                ' If moving to/from Party, redraw the Party
                                If StmtX.B(3) = 20 Or StmtX.B(1) = 20 Then
                                    frmMain.MenuDrawParty
                                End If
                            End If
                        End If
                    Case 66 ' IfText
                        If CompareVars(StmtX.B(0), StmtX.B(1), StmtX.B(2), StmtX.B(3), StmtX.B(4), sText) > 0 Then
                            .IfStack(.IfStackTop) = bdIfProcess
                        Else
                            .IfStack(.IfStackTop) = bdIfSkip
                        End If
                    Case 67 ' TargetEncounter
                        c = False
                        For Each MapX In frmMain.Area.Plot.Maps
                            For Each EncounterX In MapX.Encounters
                                If EncounterX.Name Like sText Then
                                    Set .EncounterX(4) = EncounterX
                                    c = True
                                    Exit For
                                End If
                            Next EncounterX
                            If c = True Then
                                Exit For
                            End If
                        Next MapX
                        If c = False Then
                            .Fail = 1
                        End If
                    Case 68 ' TargetTile
                        ' Validate X, Y coordinate
                        x = GetVarContext(StmtX.B(0), StmtX.B(1))
                        y = GetVarContext(StmtX.B(3), StmtX.B(4))
                        .Fail = 0
                        If PointIn(x, y, 0, 0, frmMain.Map.Width, frmMain.Map.Height) Then
                            .TileX(3) = x: .TileY(3) = y
                        Else
                            .TileX(3) = frmMain.Tome.MapX: .TileY(3) = frmMain.Tome.MapY
                            .Fail = 1
                        End If
                    Case 69 ' PlayVideo
                        frmMain.CutSceneVideo StmtX.Text, frmMain.Tome.FullPath
                    Case 70 ' Find
                        ' Find the Collection looping through
                        Select Case StmtX.B(1)
                            Case 0 To 4 ' In Encounter
                                Set ObjectX = .EncounterX(StmtX.B(1))
                            Case 5 To 9 ' In Item
                                Set ObjectX = .ItemX(StmtX.B(1) - 5)
                            Case 10 ' In Tome
                                Set ObjectX = frmMain.Tome
                            Case 11 To 15   ' In Trigger
                                Set ObjectX = .TriggerX(StmtX.B(1) - 11)
                            Case 16 To 20   ' In Creature
                                Set ObjectX = .CreatureX(StmtX.B(1) - 16)
                        End Select
                        ' Loop through and find the Thing named
                        .FoundIt = 0
                        Select Case StmtX.B(0)
                            Case 0 To 2 ' Creatures
                                For Each CreatureX In ObjectX.Creatures
                                    If InStr(UCase(CreatureX.Name), UCase(sText)) > 0 Or InStr(UCase(sText), UCase(CreatureX.Name)) > 0 Then
                                        Set .CreatureX(StmtX.B(0) + 1) = CreatureX
                                        .FoundIt = 1
                                        Exit For
                                    End If
                                Next CreatureX
                            Case 3 To 5 ' Items
                                For Each ItemX In ObjectX.Items
                                    If InStr(UCase(ItemX.Name), UCase(sText)) > 0 Or InStr(UCase(sText), UCase(ItemX.Name)) > 0 Then
                                        Set .ItemX(StmtX.B(0) - 2) = ItemX
                                        .FoundIt = 1
                                        Exit For
                                    End If
                                Next ItemX
                            Case 6 To 8 ' Triggers
                                For Each TriggerX In ObjectX.Triggers
                                    If InStr(UCase(TriggerX.Name), UCase(sText)) > 0 Or InStr(UCase(sText), UCase(TriggerX.Name)) > 0 Then
                                        Set .TriggerX(StmtX.B(0) - 5) = TriggerX
                                        .FoundIt = 1
                                        Exit For
                                    End If
                                Next TriggerX
                        End Select
                    Case 71 ' CallTrigger
                        Select Case StmtX.B(1)
                            Case 0 To 4     ' Creatures
                                Set ObjectX = .CreatureX(StmtX.B(1))
                            Case 5 To 9     ' Encounters
                                Set ObjectX = .EncounterX(StmtX.B(1) - 5)
                            Case 10 To 14   ' Items
                                Set ObjectX = .ItemX(StmtX.B(1) - 10)
                            Case 15         ' Party
                                Set ObjectX = frmMain.Tome
                            Case 16 To 20   ' Triggers
                                Set ObjectX = .TriggerX(StmtX.B(1) - 16)
                        End Select
                        .Fail = Not FireTrigger(ObjectX, .TriggerX(StmtX.B(0)))
                        ' Reset pointers back to current Trigger
                        Set FrameNow = FrameX
                    Case 72 ' CombatAnimation 'Text' For [B0] Frames [B1]
                        c = frmMain.LoadSFXPic(StmtX.Text)
                        ' If loaded and in combat...
                        If c > -1 And frmMain.picGrid.Visible = True Then
                            ' Point to the correct Creature
                            Set ObjectX = .CreatureX(StmtX.B(0))
                            Cells = StmtX.B(1) + 2: x = 0
                            Width = frmMain.picSFXPic(c).Width / (Cells * 2)
                            Height = frmMain.picSFXPic(c).Height / 2
                            frmMain.picCPic(ObjectX.Pic).Width = Width * 2
                            frmMain.picCPic(ObjectX.Pic).Height = Height * 4
                            Do Until x = Cells
                                ' Timer set here so it takes into account drawing time
                                t1 = Timer
                                ' Draw Normal and Flip
                                frmMain.picCPic(ObjectX.Pic).Cls
                                rc = BitBlt(frmMain.picCPic(ObjectX.Pic).hdc, 0, 0, Width, Height, _
                                    frmMain.picSFXPic(c).hdc, x * Width, 0, SRCCOPY)
                                rc = BitBlt(frmMain.picCPic(ObjectX.Pic).hdc, Width, 0, Width, Height, _
                                    frmMain.picSFXPic(c).hdc, (frmMain.picSFXPic(c).Width / 2) + (Cells - x - 1) * Width, 0, SRCCOPY)
                                ' Paint Mask Normal and Flip
                                rc = BitBlt(frmMain.picCPic(ObjectX.Pic).hdc, 0, Height, Width, Height, _
                                    frmMain.picSFXPic(c).hdc, x * Width, Height, SRCCOPY)
                                rc = BitBlt(frmMain.picCPic(ObjectX.Pic).hdc, Width, Height, Width, Height, _
                                    frmMain.picSFXPic(c).hdc, (frmMain.picSFXPic(c).Width) / 2 + (Cells - x - 1) * Width, Height, SRCCOPY)
                                ' Draw Normal and Flip (Yellow)
                                rc = BitBlt(frmMain.picCPic(ObjectX.Pic).hdc, 0, Height * 2, Width, Height, _
                                    frmMain.picSFXPic(c).hdc, x * Width, 0, SRCCOPY)
                                rc = BitBlt(frmMain.picCPic(ObjectX.Pic).hdc, Width, Height * 2, Width, Height, _
                                    frmMain.picSFXPic(c).hdc, (frmMain.picSFXPic(c).Width / 2) + (Cells - x - 1) * Width, 0, SRCCOPY)
                                ' Draw Normal and Flip (Red)
                                rc = BitBlt(frmMain.picCPic(ObjectX.Pic).hdc, 0, Height * 3, Width, Height, _
                                    frmMain.picSFXPic(c).hdc, x * Width, 0, SRCCOPY)
                                rc = BitBlt(frmMain.picCPic(ObjectX.Pic).hdc, Width, Height * 3, Width, Height, _
                                    frmMain.picSFXPic(c).hdc, (frmMain.picSFXPic(c).Width / 2) + (Cells - x - 1) * Width, 0, SRCCOPY)
                                frmMain.picCPic(ObjectX.Pic).Refresh
                                frmMain.CombatDraw
                                Do Until Timer - t1 > 0.05
                                Loop
                                x = x + 1
                            Loop
                            frmMain.LoadCreaturePicForce ObjectX
                            frmMain.LoadCreaturePic ObjectX
                        End If
                    Case 73 ' MapAnimation 'Text' Frames B2 Level B5 At (B0.B1, B3.B4)
                        ' Use LoadSFXPic to load picture
                        ' Alter PlotTile so that it uses an SFX picture instead of copy
                        ' from picTPic. Can't use negatives. Need somewhat to designate
                        ' that this tile is running an animation.
                        ' Then run DrawMapRegion (this will be *very* slow)
                    Case 74 ' MapRefresh
                        frmMain.DrawMapAll
                End Select
            End If
            .StatementNow = .StatementNow + 1
            If .StatementNow > .Trigger.Statements.Count Then
                .StopExit = True
            End If
            If .Ticks > 5000 Then
                .StopExit = True
                .Abort = True
            End If
        Loop
        ' Remove charge from Trigger if not 0, not a Skill Trigger and not a Timed Trigger
        If .Trigger.Turns > 0 And .Trigger.IsSkill = False And .Trigger.IsTimed = False Then
            .Trigger.Turns = .Trigger.Turns - 1
            ' If out of turns then delete trigger
            If .Trigger.Turns < 1 Then
                .ParentX.RemoveTrigger "T" & .Trigger.Index
            End If
        End If
    End With
    ' Pop stack
    PgmStack.Remove "T" & FrameX.Index
    ' Close Dialog if open
    If frmMain.picConvo.Visible = True Then
        frmMain.DialogHide
    End If
    ' Close CutScene if open
    If RefreshMap = True Then
        frmMain.DrawMapAll
    End If
    ' Abort now
    If FrameX.Abort = True Then
        FireTrigger = False
        Exit Function
    End If
    FireTrigger = (FrameX.Fail = 0)
    ' Show Trigger
    frmMain.DebugShow
End Function

Public Function ReplaceText(ByRef InString As String)
    Dim StartAt As Integer, EndAt As Integer, c As Integer
    Dim Context As String, Var As String, NewText As String
    StartAt = InStr(InString, "[")
    Do Until StartAt = 0
        EndAt = InStr(StartAt, InString, "]")
        If EndAt > 0 Then
            Context = Mid(InString, StartAt + 1, EndAt - StartAt - 1)
            c = InStr(Context, ".")
            If c > 0 Then
                Var = Mid(Context, c + 1)
                Context = Left(Context, c - 1)
            Else
                Var = "Name"
            End If
            NewText = ConvertVarContext(Context, Var)
            InString = Left(InString, StartAt - 1) & NewText & Mid(InString, EndAt + 1)
            StartAt = InStr(InString, "[")
        Else
            StartAt = 0
        End If
    Loop
    ' Substitute the \ notation for carriage return (\n) and (\)
    StartAt = InStr(InString, "\n")
    Do Until StartAt = 0
        InString = Left(InString, StartAt - 1) & Chr(13) & Chr(10) & Mid(InString, StartAt + 2)
        StartAt = InStr(InString, "\n")
    Loop
    StartAt = InStr(InString, "\")
    Do Until StartAt = 0
        InString = Left(InString, StartAt - 1) & Mid(InString, StartAt + 1)
        StartAt = InStr(InString, "\")
    Loop
    ReplaceText = InString
End Function

Public Function ConvertVarContext(InContext As String, InVar As String) As Variant
    Dim c As Integer, i As Integer, Text As String
    ConvertVarContext = ""
    For c = 0 To 32
        If InContext = ContextToText(c) Then
            For i = 0 To 255
                If InVar = VarToText(c, i) Then
                    ConvertVarContext = GetVarContext(c, i)
                    Exit For
                End If
            Next i
            Exit For
        End If
    Next c
End Function

Private Function CompareVars(InContext1 As Integer, InVar1 As Integer, Op As Integer, InContext2 As Integer, InVar2 As Integer, Optional InText As Variant) As Variant
    Dim aa As Variant, bb As Variant
    ' Function which fetches and compares two BD vars. Returns 0 if fails, 1 if succeed.
    aa = GetVarContext(InContext1, InVar1)
    If IsMissing(InText) Then
        bb = GetVarContext(InContext2, InVar2)
    Else
        bb = InText
    End If
    CompareVars = 0 ' Default to failure
    Select Case Op
        Case 0  ' =
            If IsNumeric(aa) And IsNumeric(bb) Then
                If aa = bb Then
                    CompareVars = 1
                End If
            Else
                If UCase(Format(aa)) = UCase(Format(bb)) Then
                    CompareVars = 1
                End If
            End If
        Case 1  ' +
            If IsNumeric(aa) And IsNumeric(bb) Then
                CompareVars = aa + bb
            Else
                CompareVars = Format(aa) & " " & Format(bb)
            End If
        Case 2  ' -
            CompareVars = aa - bb
        Case 3  ' *
            CompareVars = aa * bb
        Case 4  ' /
            If bb <> 0 Then
                CompareVars = aa / bb
            End If
        Case 5  ' >
            If aa > bb Then
                CompareVars = 1
            End If
        Case 6  ' <
            If aa < bb Then
                CompareVars = 1
            End If
        Case 7  ' >=
            If aa >= bb Then
                CompareVars = 1
            End If
        Case 8  ' <=
            If aa <= bb Then
                CompareVars = 1
            End If
        Case 9  ' Or
            If (aa Or bb) > 0 Then
                CompareVars = 1
            End If
        Case 10 ' And
            If (aa And bb) > 0 Then
                CompareVars = 1
            End If
        Case 11 ' Xor
            If (aa Xor bb) > 0 Then
                CompareVars = 1
            End If
        Case 12 ' Like
            If Len(aa) > 0 And Len(bb) > 0 Then
                If InStr(UCase(aa), UCase(bb)) > 0 Or InStr(UCase(bb), UCase(aa)) > 0 Then
                    CompareVars = 1
                End If
            End If
        Case 13 ' <> (Not Equal)
            If aa <> bb Then
                CompareVars = 1
            End If
    End Select
End Function

Public Function GetVarContext(AsContext As Integer, AsVar As Integer) As Variant
    Dim ObjectX As Object, TriggerX As Trigger, Found As Integer
    Dim NoFail As Integer, c As Integer, x As Integer, y As Integer
    ' Get value
    Select Case AsContext
        Case 0 'Tome
            Select Case AsVar
                Case 0
                    ' PartyCount
                    GetVarContext = frmMain.Tome.Creatures.Count
                Case 1 ' Comments
                    GetVarContext = frmMain.Tome.Comments
                Case 2 'Factoids
                    GetVarContext = ""
                    For Each ObjectX In frmMain.Tome.Factoids
                        GetVarContext = GetVarContext & "|" & ObjectX.Text
                    Next ObjectX
                Case 3
                    ' Not Used
                Case 4 'MapX
                    GetVarContext = frmMain.Tome.MapX
                Case 5 'MapY
                    GetVarContext = frmMain.Tome.MapY
                Case 6 'MoveToX
                    GetVarContext = frmMain.Tome.MoveToX
                Case 7 'MoveToY
                    GetVarContext = frmMain.Tome.MoveToY
                Case 8 'Name
                    GetVarContext = frmMain.Tome.Name
                Case 9
                    ' Not Used
                Case 10 'TimeCycle
                    GetVarContext = frmMain.Tome.Cycle
                Case 11 'TimeMoon
                    GetVarContext = frmMain.Tome.Moon
                Case 12 'TimeTurn
                    GetVarContext = frmMain.Tome.Turn
                Case 13 'TimeYear
                    GetVarContext = frmMain.Tome.Year
                Case 14 'RealSeconds
                    GetVarContext = frmMain.Tome.RealSeconds
                Case 15 'RealMinutes
                    GetVarContext = frmMain.Tome.RealMinutes
                Case 16 'RealHours
                    GetVarContext = frmMain.Tome.RealHours
                Case 17 'RealDays
                    GetVarContext = frmMain.Tome.RealDays
            End Select
        Case 1 'Map
            Select Case AsVar
                Case 0 'Comments
                    GetVarContext = frmMain.Map.Comments
                Case 1 'DefaultEncounters
                    GetVarContext = frmMain.Map.DefaultEncounters
                Case 2 'DefaultHeight
                    GetVarContext = frmMain.Map.DefaultHeight
                Case 3 'DefaultStyle
                    GetVarContext = frmMain.Map.DefaultStyle
                Case 4 'DefaultWidth
                    GetVarContext = frmMain.Map.DefaultWidth
                Case 5 'Difficulty
                Case 6 'ExperiencePoints
                    GetVarContext = frmMain.Map.ExperiencePoints
                Case 7 'Height
                    GetVarContext = frmMain.Map.Height
                Case 8 'Left
                    GetVarContext = frmMain.Map.Left
                Case 9 'Name
                    GetVarContext = frmMain.Map.Name
                Case 10 'ReGenUponEntry
                    GetVarContext = frmMain.Map.GenerateUponEntry
                Case 11 'Rune: Blood
                    GetVarContext = frmMain.Map.Runes(0)
                Case 12 'Rune: Bile
                    GetVarContext = frmMain.Map.Runes(1)
                Case 13 'Rune: Oil
                    GetVarContext = frmMain.Map.Runes(2)
                Case 14 'Rune: Nectar
                    GetVarContext = frmMain.Map.Runes(3)
                Case 15 'Rune: Fire
                    GetVarContext = frmMain.Map.Runes(4)
                Case 16 'Rune: Earth
                    GetVarContext = frmMain.Map.Runes(5)
                Case 17 'Rune: Water
                    GetVarContext = frmMain.Map.Runes(6)
                Case 18 'Rune: Air
                    GetVarContext = frmMain.Map.Runes(7)
                Case 19 'Rune: Time
                    GetVarContext = frmMain.Map.Runes(8)
                Case 20 'Rune: Moon
                    GetVarContext = frmMain.Map.Runes(9)
                Case 21 'Rune: Sun
                    GetVarContext = frmMain.Map.Runes(10)
                Case 22 'Rune: Space
                    GetVarContext = frmMain.Map.Runes(11)
                Case 23 'Rune: Insect
                    GetVarContext = frmMain.Map.Runes(12)
                Case 24 'Rune: Man
                    GetVarContext = frmMain.Map.Runes(13)
                Case 25 'Rune: Animal
                    GetVarContext = frmMain.Map.Runes(14)
                Case 26 'Rune: Fish
                    GetVarContext = frmMain.Map.Runes(15)
                Case 27 'Rune: Twilight
                    GetVarContext = frmMain.Map.Runes(16)
                Case 28 'Rune: Abyss
                    GetVarContext = frmMain.Map.Runes(17)
                Case 29 'Rune: Eternium
                    GetVarContext = frmMain.Map.Runes(18)
                Case 30 'Rune: Dreams
                    GetVarContext = frmMain.Map.Runes(19)
                Case 31 'Top
                    GetVarContext = frmMain.Map.Top
                Case 32 'Width
                    GetVarContext = frmMain.Map.Width
                Case 33 ' IsOutside
                    GetVarContext = Abs(frmMain.Map.IsOutside)
                Case 34 ' MapStyle
                    Select Case frmMain.Map.MapStyle
                        Case 0  ' Town
                            GetVarContext = "Town"
                        Case 1  ' Wilderness
                            GetVarContext = "Wilderness"
                        Case 2  ' Building
                            GetVarContext = "Building"
                        Case 3  ' Dungeon
                            GetVarContext = "Dungeon"
                    End Select
            End Select
        Case 2, 3, 4, 5, 6 'TileNow, TileA, TileB, TileC, TileTarget
            x = FrameNow.TileX(AsContext - 2): y = FrameNow.TileY(AsContext - 2)
            Select Case AsVar
                Case 0 ' CanSeeDown
                    GetVarContext = Abs(frmMain.Map.See(x, y, 3))
                Case 1 ' CanSeeLeft
                    GetVarContext = Abs(frmMain.Map.See(x, y, 2))
                Case 2 ' CanSeeRight
                    GetVarContext = Abs(frmMain.Map.See(x, y, 1))
                Case 3 ' CanSeeUp
                    GetVarContext = Abs(frmMain.Map.See(x, y, 0))
                Case 4 ' ChanceToOpen
                    Found = False: GetVarContext = 0
                    If frmMain.Map.TopTile(x, y) > 0 Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).SwapTile > 0 Then
                            GetVarContext = frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).Chance
                            Found = True
                        End If
                    End If
                    If frmMain.Map.MiddleTile(x, y) > 0 And Found = False Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).SwapTile > 0 Then
                            GetVarContext = frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).Chance
                            Found = True
                        End If
                    End If
                    If frmMain.Map.BottomTile(x, y) > 0 And Found = False Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).SwapTile > 0 Then
                            GetVarContext = frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).Chance
                            Found = True
                        End If
                    End If
                Case 5 ' Not Used
                Case 6 ' IsBlockedDown
                    GetVarContext = Abs(frmMain.Map.Blocked(x, y, 3))
                Case 7 ' IsBlockedLeft
                    GetVarContext = Abs(frmMain.Map.Blocked(x, y, 2))
                Case 8 ' IsBlockedRight
                    GetVarContext = Abs(frmMain.Map.Blocked(x, y, 1))
                Case 9 ' IsBlockedUp
                    GetVarContext = Abs(frmMain.Map.Blocked(x, y, 0))
                Case 10 ' Key
                    Found = False: GetVarContext = 0
                    If frmMain.Map.TopTile(x, y) > 0 Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).SwapTile > 0 Then
                            GetVarContext = frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).KeyBits
                            Found = True
                        End If
                    End If
                    If frmMain.Map.MiddleTile(x, y) > 0 And Found = False Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).SwapTile > 0 Then
                            GetVarContext = frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).KeyBits
                            Found = True
                        End If
                    End If
                    If frmMain.Map.BottomTile(x, y) > 0 And Found = False Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).SwapTile > 0 Then
                            GetVarContext = frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).KeyBits
                            Found = True
                        End If
                    End If
                Case 11 To 15   ' Not Used
                Case 16 ' Name
                    GetVarContext = ""
                    If frmMain.Map.BottomTile(x, y) > 0 Then
                        GetVarContext = GetVarContext & "|" & frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).Name
                    End If
                    If frmMain.Map.MiddleTile(x, y) > 0 Then
                        GetVarContext = GetVarContext & "|" & frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).Name
                    End If
                    If frmMain.Map.TopTile(x, y) > 0 Then
                        GetVarContext = GetVarContext & "|" & frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).Name
                    End If
                Case 17 ' Style
                    GetVarContext = ""
                    If frmMain.Map.BottomTile(x, y) > 0 Then
                        GetVarContext = GetVarContext & "|" & modBD.SetUpTileStyle(frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).Style)
                    End If
                    If frmMain.Map.MiddleTile(x, y) > 0 Then
                        GetVarContext = GetVarContext & "|" & modBD.SetUpTileStyle(frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).Style)
                    End If
                    If frmMain.Map.TopTile(x, y) > 0 Then
                        GetVarContext = GetVarContext & "|" & modBD.SetUpTileStyle(frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).Style)
                    End If
                Case 18 ' DoorName
                    Found = False: GetVarContext = ""
                    If frmMain.Map.TopTile(x, y) > 0 Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).SwapTile > 0 Then
                            GetVarContext = frmMain.Map.Tiles("L" & frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).SwapTile)
                            Found = True
                        End If
                    End If
                    If frmMain.Map.MiddleTile(x, y) > 0 Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).SwapTile > 0 Then
                            GetVarContext = frmMain.Map.Tiles("L" & frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).SwapTile)
                            Found = True
                        End If
                    End If
                    If frmMain.Map.BottomTile(x, y) > 0 Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).SwapTile > 0 Then
                            GetVarContext = frmMain.Map.Tiles("L" & frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).SwapTile)
                            Found = True
                        End If
                    End If
                    If Not Found Then
                        GetVarContext = "<None>"
                    End If
                Case 19 ' MovementCost
                    GetVarContext = frmMain.Map.MovementCost(x, y)
                Case 20 ' TerrainType
                    GetVarContext = ""
                    If frmMain.Map.BottomTile(x, y) > 0 Then
                        GetVarContext = GetVarContext & "|" & modBD.SetUpTileTerrain(frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).TerrainType)
                    End If
                    If frmMain.Map.MiddleTile(x, y) > 0 Then
                        GetVarContext = GetVarContext & "|" & modBD.SetUpTileTerrain(frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).TerrainType)
                    End If
                    If frmMain.Map.TopTile(x, y) > 0 Then
                        GetVarContext = GetVarContext & "|" & modBD.SetUpTileTerrain(frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).TerrainType)
                    End If
            End Select
        Case 7, 8, 9, 10, 11 'EncounterNow, EncounterA, EncounterB, EncounterC, EncounterTarget
            Set ObjectX = FrameNow.EncounterX(AsContext - 7)
            Select Case AsVar
                Case 0 ' CanFight
                    GetVarContext = Abs(ObjectX.CanFight)
                Case 1 ' CanFlee
                    GetVarContext = Abs(ObjectX.CanFlee)
                Case 2 ' CanTalk
                    GetVarContext = Abs(ObjectX.CanTalk)
                Case 3 ' ChanceToFlee
                    GetVarContext = ObjectX.ChanceToFlee
                Case 4 ' Randomize: Classification
                    GetVarContext = modBD.SetUpEncClass(ObjectX.Classification)
                Case 5 ' FirstEntry
                    GetVarContext = Abs(ObjectX.FirstEntry)
                Case 6 ' HaveEntered
                    GetVarContext = Abs(ObjectX.HaveEntered)
                Case 8 ' IsDark
                    GetVarContext = Abs(ObjectX.IsDark)
                Case 9 ' Name
                    GetVarContext = ObjectX.Name
                Case 10 ' Randomize: ThemeName
                    If ObjectX.ParentTheme > 0 Then
                        GetVarContext = frmMain.Map.Themes("R" & ObjectX.ParentTheme)
                    Else
                        GetVarContext = "<None>"
                    End If
                Case 11 ' Randomize: AddCreatures
                    GetVarContext = Abs(ObjectX.ReGenCreatures)
                Case 12 ' Randomize: AddItems
                    GetVarContext = Abs(ObjectX.ReGenItems)
                Case 13 ' Randomize: AddTriggers
                    GetVarContext = Abs(ObjectX.ReGenTriggers)
                Case 14 ' Randomize: Description
                    GetVarContext = Abs(ObjectX.ReGenNewDescriptions)
                Case 15 ' Ranzomize: GenerateUponEntry
                    GetVarContext = Abs(ObjectX.GenerateUponEntry)
                Case 16 ' SecondEntry
                    GetVarContext = Abs(ObjectX.HaveEntered)
                Case 17 ' ShowHint
                    GetVarContext = Abs(ObjectX.UseHint)
                Case 18 ' CreatureCount
                    GetVarContext = Abs(ObjectX.Creatures.Count)
                Case 19 ' ItemCount
                    GetVarContext = Abs(ObjectX.Items.Count)
            End Select
        Case 12, 13, 14, 15, 16 'CreatureNow, CreatureA, CreatureB, CreatureC, CreatureTarget
            Set ObjectX = FrameNow.CreatureX(AsContext - 12)
            Select Case AsVar
                Case 0 To 7 ' BodyPart1-8
                    GetVarContext = ObjectX.BodyType(AsVar)
                Case 8 To 15 ' Resistance1-8
                    GetVarContext = ObjectX.ResistanceWithArmor(AsVar - 8)
                Case 16 ' Col
                    GetVarContext = ObjectX.Col
                Case 17 ' Comments
                    GetVarContext = ObjectX.Comments
                Case 18 ' ActionPoints
                    GetVarContext = ObjectX.ActionPoints
                Case 19 ' ExperiencePoints
                    GetVarContext = ObjectX.ExperiencePoints
                Case 20 ' ExperienceLevel
                    GetVarContext = ObjectX.Level
                Case 21 ' Not Used
                Case 22 ' Greed
                    GetVarContext = ObjectX.Greed
                Case 23 ' HealthNow
                    GetVarContext = ObjectX.HPNow
                Case 24 ' HealthMax
                    GetVarContext = ObjectX.HPMax
                Case 25 ' Lunacy
                    GetVarContext = ObjectX.Lunacy
                Case 26 ' Lust
                    GetVarContext = ObjectX.Lust
                Case 27 ' Not Used
                Case 28 ' IsAgressive
                    GetVarContext = Abs(ObjectX.Agressive)
                Case 29 ' IsDMControlled
                    GetVarContext = Abs(ObjectX.DMControlled)
                Case 30 ' IsFriendly
                    GetVarContext = Abs(ObjectX.Friendly)
                Case 31 ' IsGuarding
                    GetVarContext = Abs(ObjectX.Guard)
                Case 32 To 39 ' ProtectionSharp, Blunt, Cold, Fire, Evil, Holy, Magic, Mind
                    GetVarContext = ObjectX.ResistanceTypeWithArmor(AsVar - 31)
                Case 46 ' IsTypeAnimal
                    GetVarContext = Abs(ObjectX.Family(4))
                Case 47 ' IsTypeBird
                    GetVarContext = Abs(ObjectX.Family(6))
                Case 48 ' IsTypeBlob
                    GetVarContext = Abs(ObjectX.Family(3))
                Case 49 ' IsTypeFamily
                    GetVarContext = Abs(ObjectX.Family(8))
                Case 50 ' IsTypeHuge
                    GetVarContext = Abs(ObjectX.Size(4))
                Case 51 ' IsTypeHuman
                    GetVarContext = Abs(ObjectX.Family(0))
                Case 52 ' IsTypeInsect
                    GetVarContext = Abs(ObjectX.Family(2))
                Case 53 ' IsTypeLarge
                    GetVarContext = Abs(ObjectX.Size(3))
                Case 54 ' IsTypeMagical
                    GetVarContext = Abs(ObjectX.Family(9))
                Case 55 ' IsTypeMedium
                    GetVarContext = Abs(ObjectX.Size(2))
                Case 56 ' IsTypeReptile
                    GetVarContext = Abs(ObjectX.Family(1))
                Case 57 ' IsTypeSmall
                    GetVarContext = Abs(ObjectX.Size(1))
                Case 58 ' IsTypeTiny
                    GetVarContext = Abs(ObjectX.Size(0))
                Case 59 ' IsTypeVeggie
                    GetVarContext = Abs(ObjectX.Family(5))
                Case 60 ' IsTypeUndead
                    GetVarContext = Abs(ObjectX.Family(7))
                Case 75 ' Eternium
                    GetVarContext = ObjectX.Eternium
                Case 76 ' MapX
                    GetVarContext = ObjectX.MapX
                Case 77 ' MapY
                    GetVarContext = ObjectX.MapY
                Case 78 ' Name
                    GetVarContext = ObjectX.Name
                Case 79 ' Strength
                    GetVarContext = ObjectX.Strength
                Case 80 ' Pride
                    GetVarContext = ObjectX.Pride
                Case 81 ' Race
                    GetVarContext = ObjectX.Race
                Case 82 ' Revelry
                    GetVarContext = ObjectX.Revelry
                Case 83 ' Row
                    GetVarContext = ObjectX.Row
                Case 84 ' RuneQue1
                    GetVarContext = ObjectX.Runes(0)
                Case 85 ' RuneQue2
                    GetVarContext = ObjectX.Runes(1)
                Case 86 ' RuneQue3
                    GetVarContext = ObjectX.Runes(2)
                Case 87 ' RuneQue4
                    GetVarContext = ObjectX.Runes(3)
                Case 88 ' RuneQue5
                    GetVarContext = ObjectX.Runes(4)
                Case 89 ' RuneQue6
                    GetVarContext = ObjectX.Runes(5)
                Case 90 ' ScarletLetter
                    GetVarContext = ObjectX.ScarletLetter
                Case 91 ' Agility
                    GetVarContext = ObjectX.Agility
                Case 92 ' SkillPoints
                    GetVarContext = ObjectX.SkillPoints
                Case 93 ' Status
                    GetVarContext = ObjectX.StatusText
                Case 94 ' Not Used
                    ' Not Used
                Case 95 ' Defense
                    GetVarContext = ObjectX.Defense
                Case 96 ' Will
                    GetVarContext = ObjectX.Will
                Case 97 ' Wrath
                    GetVarContext = ObjectX.Wrath
                Case 98 ' IsMale
                    GetVarContext = ObjectX.Male
                Case 99 ' IsUnconscious
                    GetVarContext = ObjectX.Unconscious
                Case 100 ' IsFrozen
                    GetVarContext = ObjectX.Frozen
                Case 101 ' RangeToTarget
                    GetVarContext = Int(Sqr((ObjectX.Col - FrameNow.CreatureX(4).Col) ^ 2 + (ObjectX.Row - FrameNow.CreatureX(4).Row) ^ 2))
                Case 102 ' ActionPointsMax
                    GetVarContext = ObjectX.ActionPointsMax
                Case 103 To 110 ' ProtectionBonusSharp, Blunt, Cold, Fire, Evil, Holy, Magic, Mind
                    GetVarContext = ObjectX.ResistanceBonus(AsVar - 102)
                Case 111    ' ResistanceBonus (everthing but the specials above)
                    GetVarContext = ObjectX.ResistanceBonus(0)
                Case 133 ' EterniumMax
                    GetVarContext = ObjectX.EterniumMax
                Case 134 ' WeightMax
                    GetVarContext = ObjectX.MaxWeight
                Case 135 ' Weight
                    GetVarContext = ObjectX.Weight
                Case 136 ' Bulk
                    GetVarContext = ObjectX.Bulk
                Case 137 ' StrengthBonus
                    GetVarContext = ObjectX.StrengthBonus
                Case 138 ' AgilityBonus
                    GetVarContext = ObjectX.AgilityBonus
                Case 139 ' WillBonus
                    GetVarContext = ObjectX.WillBonus
                Case 140 ' AttackBonus
                    GetVarContext = ObjectX.AttackBonus
                Case 141 ' DamageBonus
                    GetVarContext = ObjectX.DamageBonus
                Case 142 ' DefenseBonus
                    GetVarContext = ObjectX.DefenseBonus
                Case 143 ' ArmorBonus
                    GetVarContext = ObjectX.ArmorBonus
                Case 144 ' IsSpellCaster
                    GetVarContext = Abs(ObjectX.IsSpellCaster)
                Case 145 ' Money
                    GetVarContext = ObjectX.Money
                Case 146 ' ActionPointsMax
                    GetVarContext = ObjectX.ActionPointsMax
                Case 147 ' IsAfraid
                    GetVarContext = Abs(ObjectX.Afraid)
                Case 148 ' IsInanimate
                    GetVarContext = Abs(ObjectX.IsInanimate)
                Case 149 ' Not Used
                Case 150 ' CombatRank
                    GetVarContext = ObjectX.CombatRank
                Case 151 ' Pronoun_HeShe
                    GetVarContext = ObjectX.Pronoun(1)
                Case 152 ' Pronoun_HimHer
                    GetVarContext = ObjectX.Pronoun(2)
                Case 153 ' Pronoun_HisHer
                    GetVarContext = ObjectX.Pronoun(3)
                Case 154 ' MovementCost
                    GetVarContext = ObjectX.MovementCost
                Case 155 ' MovementCostBonus
                    GetVarContext = ObjectX.MovementCostBonus
                Case 156 ' Index
                    GetVarContext = ObjectX.Index
                Case 157 ' PictureFile
                    GetVarContext = ObjectX.PictureFile
                Case 158 ' FaceLeft
                    GetVarContext = ObjectX.FaceLeft
                Case 159 ' FaceTop
                    GetVarContext = ObjectX.FaceTop
                Case 160 ' Initiative
                    GetVarContext = ObjectX.Initiative
                Case 161 ' Facing
                    GetVarContext = ObjectX.Facing
            End Select
        Case 17, 18, 19, 20, 21 'ItemNow, ItemA, ItemB, ItemC, ItemTarget
            Set ObjectX = FrameNow.ItemX(AsContext - 17)
            Select Case AsVar
                Case 0 ' Protection%
                    GetVarContext = ObjectX.Resistance
                Case 1 ' Bulk
                    GetVarContext = ObjectX.Bulk
                Case 2 ' CanCombine
                    GetVarContext = Abs(ObjectX.CanCombine)
                Case 3 ' ArmorType
                    GetVarContext = modBD.SetUpWearType(ObjectX.WearType)
                Case 16 ' Capacity
                    GetVarContext = ObjectX.Capacity
                Case 18 ' Comments
                    GetVarContext = ObjectX.Comments
                Case 19 ' Count
                    GetVarContext = ObjectX.Count
                Case 20 ' DamageDice
                    GetVarContext = ObjectX.Damage
                Case 21 ' DamageBonus
                    GetVarContext = ObjectX.DamageBonus
                Case 22 ' IsWeaponMelee
                    GetVarContext = Abs(ObjectX.Family = 5)
                Case 23 ' IsWeaponRanged
                    GetVarContext = Abs(ObjectX.Family = 7)
                Case 24 ' IsEquipped
                    GetVarContext = Abs(ObjectX.IsReady)
                Case 25 ' IsWeaponThrown
                    GetVarContext = Abs(ObjectX.Family = 8)
                Case 26 ' Key
                    GetVarContext = Abs(ObjectX.KeyBits)
                Case 27 ' ProtectionBonusType
                    GetVarContext = ObjectX.ResistanceType
                Case 28 ' ProtectionBonus
                    GetVarContext = ObjectX.ResistanceBonus
                Case 29 ' IsWeaponAmmo
                    GetVarContext = Abs(ObjectX.Family = 6)
                Case 31 ' IsRangeLong
                    GetVarContext = Abs(ObjectX.RangeType = 2)
                Case 32 ' IsRangeMedium
                    GetVarContext = Abs(ObjectX.RangeType = 1)
                Case 33 ' IsRangeShort
                    GetVarContext = Abs(ObjectX.RangeType = 0)
                Case 36 ' IsSoftBulk
                    GetVarContext = Abs(ObjectX.SoftCapacity)
                Case 37 ' IsDamageTypeSharp
                    GetVarContext = Abs(ObjectX.DamageType = 1)
                Case 38 ' IsDamageTypeBlunt
                    GetVarContext = Abs(ObjectX.DamageType = 2)
                Case 39 ' IsDamageTypeCold
                    GetVarContext = Abs(ObjectX.DamageType = 3)
                Case 40 ' IsDamageTypeFire
                    GetVarContext = Abs(ObjectX.DamageType = 4)
                Case 41 ' IsDamageTypeHoly
                    GetVarContext = Abs(ObjectX.DamageType = 6)
                Case 42 ' IsDamageTypeEvil
                    GetVarContext = Abs(ObjectX.DamageType = 5)
                Case 43 ' IsDamageTypeMagic
                    GetVarContext = Abs(ObjectX.DamageType = 7)
                Case 44 ' IsDamageTypeMind
                    GetVarContext = Abs(ObjectX.DamageType = 8)
                Case 50 ' MapX
                    GetVarContext = ObjectX.MapX
                Case 51 ' MapY
                    GetVarContext = ObjectX.MapY
                Case 52 ' Name
                    GetVarContext = ObjectX.NameText
                Case 53 ' DefenseBonus
                    GetVarContext = ObjectX.Defense
                Case 55 ' AttackBonus
                    GetVarContext = ObjectX.AttackBonus
                Case 56 ' UseAsDescription
                    GetVarContext = Abs(ObjectX.UseDescription)
                Case 57 ' Value
                    GetVarContext = ObjectX.Value
                Case 58 ' Weight
                    GetVarContext = ObjectX.Weight
                Case 59 ' RequiresTwoHands
                    GetVarContext = Abs(ObjectX.WearType = 11)
                Case 60 ' IsInHand
                    GetVarContext = Abs(ObjectX.InHand)
                Case 61 ' AmmoType
                    GetVarContext = ObjectX.ShootType
                Case 64 ' Family
                    GetVarContext = modBD.SetUpItemFamily(ObjectX.Family)
                Case 65 ' ActionPoints
                    GetVarContext = ObjectX.ActionPoints
            End Select
        Case 22, 23, 24, 25, 26 'TriggerNow, TriggerA, TriggerB, TriggerC, TriggerTarget
            Set ObjectX = FrameNow.TriggerX(AsContext - 22)
            Select Case AsVar
                Case 0 'ByteA
                    GetVarContext = ObjectX.VarA
                Case 1 'ByteB
                    GetVarContext = ObjectX.VarB
                Case 2 'ByteC
                    GetVarContext = ObjectX.VarC
                Case 3 'Comments
                    GetVarContext = ObjectX.Comments
                Case 4 ' Not Used
                Case 5 'IsTimed
                    GetVarContext = Abs(ObjectX.IsTimed)
                Case 6 'IsCurse
                    GetVarContext = Abs(ObjectX.IsCurse)
                Case 7 'IsEvil
                    GetVarContext = Abs(ObjectX.IsEvil)
                Case 8 'IsFear
                    GetVarContext = Abs(ObjectX.IsFear)
                Case 9 'IsFish
                    GetVarContext = Abs(ObjectX.IsFish)
                Case 10 'IsGreed
                    GetVarContext = Abs(ObjectX.IsGreed)
                Case 11 'IsLunacy
                    GetVarContext = Abs(ObjectX.IsLunacy)
                Case 12 'IsLust
                    GetVarContext = Abs(ObjectX.IsLust)
                Case 13 'IsPoison
                    GetVarContext = Abs(ObjectX.IsPoison)
                Case 14 'IsPride
                    GetVarContext = Abs(ObjectX.IsPride)
                Case 15 'IsMagic
                    GetVarContext = Abs(ObjectX.IsMagic)
                Case 16 'IsSkill
                    GetVarContext = Abs(ObjectX.IsSkill)
                Case 17 'IsRevelry
                    GetVarContext = Abs(ObjectX.IsRevelry)
                Case 18 'IsTrap
                    GetVarContext = Abs(ObjectX.IsTrap)
                Case 19 'IsWrath
                    GetVarContext = Abs(ObjectX.IsWrath)
                Case 20 'Name
                    GetVarContext = ObjectX.Name
                Case 21 ' SkillPoints
                    GetVarContext = ObjectX.SkillPoints
                Case 22 'TriggerType
                    GetVarContext = TriggerName(ObjectX.TriggerType)
                Case 23 'Turns
                    GetVarContext = ObjectX.Turns
                Case 24 'SkillLevel
                    If ObjectX.SkillPoints > 0 And ObjectX.Turns > 0 Then
                        GetVarContext = Int(ObjectX.SkillPoints / ObjectX.Turns)
                    Else
                        GetVarContext = 0
                    End If
            End Select
        Case 27 'Local
            Select Case AsVar
                Case 0 'Abort
                    GetVarContext = FrameNow.Abort
                Case 1 'ByteA
                    GetVarContext = FrameNow.ByteA
                Case 2 'ByteB
                    GetVarContext = FrameNow.ByteB
                Case 3 'ByteC
                    GetVarContext = FrameNow.ByteC
                Case 4 'Fail
                    GetVarContext = FrameNow.Fail
                Case 5 'IntegerA
                    GetVarContext = FrameNow.IntegerA
                Case 6 'IntegerB
                    GetVarContext = FrameNow.IntegerB
                Case 7 'IntegerC
                    GetVarContext = FrameNow.IntegerC
                Case 8 'StopExit
                    GetVarContext = FrameNow.StopExit
                Case 9 'TextA
                    GetVarContext = FrameNow.TextA
                Case 10 'TextB
                    GetVarContext = FrameNow.TextB
                Case 11 'TextC
                    GetVarContext = FrameNow.TextC
                Case 12 'Random
                    GetVarContext = FrameNow.Random
                Case 13 ' FoundIt
                    GetVarContext = FrameNow.FoundIt
            End Select
        Case 28 'Global
            Select Case AsVar
                Case 0  ' False
                    GetVarContext = 0
                Case 1  ' True
                    GetVarContext = 1
                Case 2 ' InCombat
                    GetVarContext = Abs(frmMain.picGrid.Visible = True)
                Case 3 ' DieTypeRoll
                    GetVarContext = frmMain.GlobalDieTypeRoll
                Case 4 ' DieCountRoll
                    GetVarContext = frmMain.GlobalDieCountRoll
                Case 5 ' ArmorRoll
                    GetVarContext = frmMain.GlobalArmorRoll
                Case 6 ' HitRoll
                    GetVarContext = frmMain.GlobalAttackRoll
                Case 7 ' DamageRoll
                    GetVarContext = frmMain.GlobalDamageRoll
                Case 8  ' Offer
                    GetVarContext = frmMain.GlobalOffer
                Case 9 To 28 ' RunePool
                    GetVarContext = frmMain.GetRunePool(AsVar - 9)
                Case 29 ' SkillLevel
                    GetVarContext = frmMain.GlobalSkillLevel
                Case 30 'IsAttackStyleAir
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H200) > 0)
                Case 31 'IsAttackStyleBlunt
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H800) > 0)
                Case 32 'IsAttackStyleEarth
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H100) > 0)
                Case 33 'IsAttackStyleFire
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H80) > 0)
                Case 34 'IsAttackStyleHoly
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H8) > 0)
                Case 35 'IsAttackStyleDisease
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H2) > 0)
                Case 36 'IsAttackStyleMagic
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H20) > 0)
                Case 37 'IsAttackStyleSharp
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H400) > 0)
                Case 38 'IsAttackStyleEvil
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H4) > 0)
                Case 39 'IsAttackStyleCold
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H1) > 0)
                Case 40 'IsAttackStyleIllusion
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H20) > 0)
                Case 41 'IsAttackStyleWater
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H80) > 0)
                Case 42 'IsAttackStyleFear
                    GetVarContext = Abs((frmMain.GlobalDamageStyle And &H10) > 0)
                Case 43 To 57
                    ' Not Used
                Case 58 ' IntegerA
                    GetVarContext = frmMain.GlobalIntegerA
                Case 59 ' IntegerB
                    GetVarContext = frmMain.GlobalIntegerB
                Case 60 ' IntegerC
                    GetVarContext = frmMain.GlobalIntegerC
                Case 61 ' TextA
                    GetVarContext = frmMain.GlobalTextA
                Case 62 ' TextB
                    GetVarContext = frmMain.GlobalTextB
                Case 63 ' TextC
                    GetVarContext = frmMain.GlobalTextC
                Case 64 ' DayName
                    GetVarContext = frmMain.GlobalDayName
                Case 65 ' MoonName
                    GetVarContext = frmMain.GlobalMoonName
                Case 66 ' YearName
                    GetVarContext = frmMain.GlobalYearName
                Case 67 ' TurnName
                    GetVarContext = frmMain.GlobalTurnName
                Case 68 ' PickLockChance
                    GetVarContext = frmMain.GlobalPickLockChance
                Case 69 ' Not Used
                Case 70 ' RemoveTrapChance
                    GetVarContext = frmMain.GlobalRemoveTrapChance
                Case 71 ' HitLocation
                    GetVarContext = frmMain.GlobalHitLocation
                Case 72 ' SpellFizzleChance
                    GetVarContext = frmMain.GlobalSpellFizzleChance
                Case 73 ' Ticks
                    GetVarContext = frmMain.GlobalTicks
            End Select
        Case 29 'Pos
            GetVarContext = AsVar
        Case 30 'Neg
            GetVarContext = -AsVar
        Case 31 'Dice
            GetVarContext = 0
            For c = 1 To AsVar Mod 5 + 1
                GetVarContext = GetVarContext + Int(Rnd * (Int((AsVar Mod 25) / 5) * 2 + 4) + 1)
            Next c
            If AsVar > 24 Then
                GetVarContext = GetVarContext + Int(AsVar / 25)
            End If
        Case 32 'Random
            GetVarContext = Int(Rnd * (AsVar + 1)) + 1
        Case Else
            GetVarContext = 0
    End Select
End Function

Private Sub PutVarContext(IntoContext As Integer, IntoVar As Integer, AsValue As Variant)
    Dim ObjectX As Object, FactoidX As Factoid, x As Integer, y As Integer, Found As Integer
    Dim sByte As Byte, sInteger As Integer, sText As String, ThemeX As Theme
    ' Smudge the AsValue into Byte, Integer and Text
    If IsNumeric(AsValue) Then
        If AsValue > 255 Then
            sByte = 255
        ElseIf AsValue < 0 Then
            sByte = 0
        Else
            sByte = CByte(AsValue)
        End If
        If AsValue > 32000 Then
            sInteger = 32000
        ElseIf AsValue < -32000 Then
            sInteger = -32000
        Else
            sInteger = CInt(AsValue)
        End If
    Else
        sByte = 0: sInteger = 0
    End If
    sText = Format(AsValue)
    Select Case IntoContext
        Case 0  ' Tome
            Select Case IntoVar
                Case 0 ' PartyCount
                    ' Read Only
                Case 1 ' Comments
                    frmMain.Tome.Comments = sText
                Case 2 'Factoids
                    Set FactoidX = frmMain.Tome.AddFactoid
                    FactoidX.Text = sText
                Case 3
                    ' Not Used
                Case 4 'MapX
                    ' Read Only
                Case 5 'MapY
                    ' Read Only
                Case 6 'MoveToX
                    frmMain.Tome.MoveToX = sByte
                Case 7 'MoveToY
                    frmMain.Tome.MoveToY = sByte
                Case 8 'Name
                    frmMain.Tome.Name = sText
                Case 9
                    ' Not Used
                Case 10 'TimeCycle
                    frmMain.Tome.Cycle = sByte
                Case 11 'TimeMoon
                    frmMain.Tome.Moon = sByte
                Case 12 'TimeTurn
                    frmMain.Tome.Turn = sByte
                Case 13 'TimeYear
                    frmMain.Tome.Year = sInteger
                Case 14 'RealSeconds
                    ' Read Only
                Case 15 'RealMinutes
                    ' Read Only
                Case 16 'RealHours
                    ' Read Only
                Case 17 'RealDays
                    ' Read Only
            End Select
        Case 1 'Map
            Select Case IntoVar
                Case 0 'Comments
                    frmMain.Map.Comments = sText
                Case 1 'Randomize: Encounter Count
                    frmMain.Map.DefaultEncounters = sInteger
                Case 2 'Randomize: Height
                    frmMain.Map.DefaultHeight = sInteger
                Case 3 'Randomize: Map Style
                    frmMain.Map.DefaultStyle = sInteger
                Case 4 'Randomize: Map Width
                    frmMain.Map.DefaultWidth = sInteger
                Case 5 'Randomize: Difficulty
                Case 6 'Randomize: ExperiencePoints
                    frmMain.Map.ExperiencePoints = sInteger
                Case 7 'Height
                    ' Read Only
                Case 8 'Left
                    ' Read Only
                Case 9 'Name
                    frmMain.Map.Name = sText
                Case 10 'ReGenUponEntry
                    frmMain.Map.GenerateUponEntry = (sInteger <> 0)
                Case 11 'Rune: Blood
                    frmMain.Map.Runes(0) = sInteger
                Case 12 'Rune: Bile
                    frmMain.Map.Runes(1) = sInteger
                Case 13 'Rune: Oil
                    frmMain.Map.Runes(2) = sInteger
                Case 14 'Rune: Nectar
                    frmMain.Map.Runes(3) = sInteger
                Case 15 'Rune: Fire
                    frmMain.Map.Runes(4) = sInteger
                Case 16 'Rune: Earth
                    frmMain.Map.Runes(5) = sInteger
                Case 17 'Rune: Water
                    frmMain.Map.Runes(6) = sInteger
                Case 18 'Rune: Air
                    frmMain.Map.Runes(7) = sInteger
                Case 19 'Rune: Time
                    frmMain.Map.Runes(8) = sInteger
                Case 20 'Rune: Moon
                    frmMain.Map.Runes(9) = sInteger
                Case 21 'Rune: Sun
                    frmMain.Map.Runes(10) = sInteger
                Case 22 'Rune: Space
                    frmMain.Map.Runes(11) = sInteger
                Case 23 'Rune: Insect
                    frmMain.Map.Runes(12) = sInteger
                Case 24 'Rune: Man
                    frmMain.Map.Runes(13) = sInteger
                Case 25 'Rune: Animal
                    frmMain.Map.Runes(14) = sInteger
                Case 26 'Rune: Fish
                    frmMain.Map.Runes(15) = sInteger
                Case 27 'Rune: Twilight
                    frmMain.Map.Runes(16) = sInteger
                Case 28 'Rune: Abyss
                    frmMain.Map.Runes(17) = sInteger
                Case 29 'Rune: Eternium
                    frmMain.Map.Runes(18) = sInteger
                Case 30 'Rune: Dreams
                    frmMain.Map.Runes(19) = sInteger
                Case 31 'Top
                    ' Read Only
                Case 32 'Width
                    ' Read Only
                Case 33 'IsOutsideMap
                    ' Read Only
                Case 34 'MapStyle
                    ' Read Only
            End Select
        Case 2, 3, 4, 5, 6 'TileNow, TileA, TileB, TileC, TileTarget
            x = FrameNow.TileX(IntoContext - 2): y = FrameNow.TileY(IntoContext - 2)
            Select Case IntoVar
                Case 0 ' CanSeeDown
                    ' Read Only
                Case 1 ' CanSeeLeft
                    ' Read Only
                Case 2 ' CanSeeRight
                    ' Read Only
                Case 3 ' CanSeeUp
                    ' Read Only
                Case 4 ' ChanceToOpen
                    Found = False
                    If frmMain.Map.TopTile(x, y) > 0 Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).SwapTile > 0 Then
                            frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).Chance = sByte
                            Found = True
                        End If
                    End If
                    If frmMain.Map.MiddleTile(x, y) > 0 And Found = False Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).SwapTile > 0 Then
                            frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).Chance = sByte
                            Found = True
                        End If
                    End If
                    If frmMain.Map.BottomTile(x, y) > 0 And Found = False Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).SwapTile > 0 Then
                            frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).Chance = sByte
                            Found = True
                        End If
                    End If
                Case 5 ' Not Used
                Case 6 ' IsBlockedDown
                    ' Read Only
                Case 7 ' IsBlockedLeft
                    ' Read Only
                Case 8 ' IsBlockedRight
                    ' Read Only
                Case 9 ' IsBlockedUp
                    ' Read Only
                Case 10 ' Key
                    Found = False
                    If frmMain.Map.TopTile(x, y) > 0 Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).SwapTile > 0 Then
                            frmMain.Map.Tiles("L" & frmMain.Map.TopTile(x, y)).Key = sByte
                            Found = True
                        End If
                    End If
                    If frmMain.Map.MiddleTile(x, y) > 0 And Found = False Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).SwapTile > 0 Then
                            frmMain.Map.Tiles("L" & frmMain.Map.MiddleTile(x, y)).Key = sByte
                            Found = True
                        End If
                    End If
                    If frmMain.Map.BottomTile(x, y) > 0 And Found = False Then
                        If frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).SwapTile > 0 Then
                            frmMain.Map.Tiles("L" & frmMain.Map.BottomTile(x, y)).Key = sByte
                            Found = True
                        End If
                    End If
                Case 16 ' Name
                    ' Read Only
                Case 17 ' Style
                    ' Read Only
                Case 18 ' DoorTileName
                    ' Read Only
                Case 19 ' MovementCost
                    ' Read Only
                Case 20 ' TerrainType
                    ' Read Only
            End Select
        Case 7, 8, 9, 10, 11 'EncounterNow, EncounterA, EncounterB, EncounterC, EncounterTarget
            Set ObjectX = FrameNow.EncounterX(IntoContext - 7)
            Select Case IntoVar
                Case 0 ' CanFight
                    ObjectX.CanFight = (sInteger <> 0)
                Case 1 ' CanFlee
                    ObjectX.CanFlee = (sInteger <> 0)
                Case 2 ' CanTalk
                    ObjectX.CanTalk = (sInteger <> 0)
                Case 3 ' ChanceToFlee
                    ObjectX.ChanceToFlee = sInteger
                Case 4 ' Classification
                    ' Read Only
                Case 5 ' FirstEntry
                    ObjectX.FirstEntry = (sInteger <> 0)
                Case 6 ' HaveEntered
                    ObjectX.HaveEntered = (sInteger <> 0)
                Case 7 ' Not Used
                Case 8 ' IsDark
                    ObjectX.IsDark = (sInteger <> 0)
                Case 9 ' Name
                    ObjectX.Name = sText
                Case 10 ' Randomize: ThemeName
                    For Each ThemeX In frmMain.Map.Themes
                        If InStr(UCase(ThemeX.Name), UCase(sText)) > 0 Then
                            ObjectX.ParentTheme = ThemeX.Index
                        End If
                    Next ThemeX
                Case 11 ' Randomize: AddCreatures
                    ObjectX.ReGenCreatures = (sInteger <> 0)
                Case 12 ' Randomize: AddItems
                    ObjectX.ReGenItems = (sInteger <> 0)
                Case 13 ' Randomize: AddTriggers
                    ObjectX.ReGenTriggers = (sInteger <> 0)
                Case 14 ' Randomize: Description
                    ObjectX.ReGenNewDescriptions = (sInteger <> 0)
                Case 15 ' Randomize: GenerateUponEntry
                    ObjectX.GenerateUponEntry = (sInteger <> 0)
                Case 16 ' SecondEntry
                    ObjectX.HaveEntered = (sInteger <> 0)
                Case 17 ' ShowHint
                    ObjectX.UseHint = (sInteger <> 0)
                Case 18 ' CreatureCount
                    ' Read Only
                Case 19 ' ItemCount
                    ' Read Only
                Case 20 ' IsActive
                    ' If changing the status, then redraw the map
                    If ObjectX.IsActive <> (sInteger <> 0) Then
                        ObjectX.IsActive = (sInteger <> 0)
                        frmMain.DrawMapAll
                        ' If turned on where the Party stands, enter it!
                        If ObjectX.Index = frmMain.Map.EncPointer(frmMain.Tome.MapX, frmMain.Tome.MapY) Then
                            If ObjectX.IsActive = True And frmMain.Map.EncPointer(frmMain.Tome.MapX, frmMain.Tome.MapY) > 0 Then
                                Set frmMain.EncounterNow = frmMain.Map.Encounters("E" & frmMain.Map.EncPointer(frmMain.Tome.MapX, frmMain.Tome.MapY))
                                frmMain.EncounterEnter
                            Else
                                Set frmMain.EncounterNow = New Encounter
                            End If
                        End If
                    End If
            End Select
        Case 12, 13, 14, 15, 16 'CreatureNow, CreatureA, CreatureB, CreatureC, CreatureTarget
            Set ObjectX = FrameNow.CreatureX(IntoContext - 12)
            Select Case IntoVar
                Case 0 To 7 ' BodyType 1 to 8
                    ' Read Only
                Case 8 To 15 ' Resistance 1 to 8
                    ' Read Only
                Case 16 ' Col
                    ObjectX.Col = Least(CInt(sByte), bdCombatWidth)
                Case 17 ' Comments
                    ObjectX.Comments = sText
                Case 18 ' Action Points
                    ObjectX.ActionPoints = sInteger
                Case 19 ' ExperiencePoints
                    ' Read Only
                Case 20 ' ExperienceLevel
                    ' Read Only
                Case 21 ' Not Used
                Case 22 ' Greed
                    ObjectX.Greed = sByte
                Case 23 ' HealthNow
                    ObjectX.HPNow = sInteger
                    frmMain.MenuDrawParty
                Case 24 ' HealthMax
                    ObjectX.HPMax = sInteger
                    frmMain.MenuDrawParty
                Case 25 ' Lunacy
                    ObjectX.Lunacy = sByte
                Case 26 ' Lust
                    ObjectX.Lust = sByte
                Case 27 ' Not Used
                Case 28 ' IsAgressive
                    ObjectX.Agressive = (sInteger <> 0)
                Case 29 ' IsDMControlled
                    ObjectX.DMControlled = (sInteger <> 0)
                Case 30 ' IsFriendly
                    ObjectX.Friendly = (sInteger <> 0)
                Case 31 ' IsGuarding
                    ObjectX.Guard = (sInteger <> 0)
                Case 32 To 39 ' ResistanceSharp, Blunt, Cold, Fire, Evil, Holy, Magic, Mind
                    ' Read Only
                Case 46 ' IsTypeAnimal
                    ObjectX.Family(4) = (sInteger <> 0)
                Case 47 ' IsTypeBird
                    ObjectX.Family(6) = (sInteger <> 0)
                Case 48 ' IsTypeBlob
                    ObjectX.Family(3) = (sInteger <> 0)
                Case 49 ' IsTypeFamily
                    ObjectX.Family(8) = (sInteger <> 0)
                Case 50 ' IsTypeHuge
                    ObjectX.Size(4) = (sInteger <> 0)
                Case 51 ' IsTypeHuman
                    ObjectX.Family(0) = (sInteger <> 0)
                Case 52 ' IsTypeInsect
                    ObjectX.Family(2) = (sInteger <> 0)
                Case 53 ' IsTypeLarge
                    ObjectX.Size(3) = (sInteger <> 0)
                Case 54 ' IsTypeMagical
                    ObjectX.Family(9) = (sInteger <> 0)
                Case 55 ' IsTypeMedium
                    ObjectX.Size(2) = (sInteger <> 0)
                Case 56 ' IsTypeReptile
                    ObjectX.Family(1) = (sInteger <> 0)
                Case 57 ' IsTypeSmall
                    ObjectX.Size(1) = (sInteger <> 0)
                Case 58 ' IsTypeTiny
                    ObjectX.Size(0) = (sInteger <> 0)
                Case 59 ' IsTypeVeggie
                    ObjectX.Family(5) = (sInteger <> 0)
                Case 60 ' IsTypeUndead
                    ObjectX.Family(7) = (sInteger <> 0)
                Case 75 ' Eternium
                    ObjectX.Eternium = sByte
                    frmMain.MenuDrawParty
                Case 76 ' MapX
                    ' Read Only
                Case 77 ' MapY
                    ' Read Only
                Case 78 ' Name
                    ObjectX.Name = sText
                Case 79 ' Strength
                    ObjectX.Strength = sByte
                Case 80 ' Pride
                    ObjectX.Pride = sByte
                Case 81 ' Race
                    ObjectX.Race = sText
                Case 82 ' Revelry
                    ObjectX.Revelry = sByte
                Case 83 ' Row
                    ObjectX.Row = Least(CInt(sByte), bdCombatHeight)
                Case 84 ' RuneQue1
                    ObjectX.Runes(0) = sByte
                Case 85 ' RuneQue2
                    ObjectX.Runes(1) = sByte
                Case 86 ' RuneQue3
                    ObjectX.Runes(2) = sByte
                Case 87 ' RuneQue4
                    ObjectX.Runes(3) = sByte
                Case 88 ' RuneQue5
                    ObjectX.Runes(4) = sByte
                Case 89 ' RuneQue6
                    ObjectX.Runes(5) = sByte
                Case 90 ' ScarletLetter
                Case 91 ' Agility
                    ObjectX.Agility = sByte
                Case 92 ' SkillPoints
                    ObjectX.SkillPoints = sInteger
                Case 93 ' Status
                    ' Read Only
                Case 94 ' Not Used
                    ' Not Used
                Case 95 ' Attack
                    ' Read Only
                Case 96 ' Will
                    ObjectX.Will = sByte
                Case 97 ' Wrath
                    ObjectX.Wrath = sByte
                Case 98 ' Male
                    ObjectX.Male = (sInteger <> 0)
                Case 99 ' Unconscious
                    ObjectX.Unconscious = (sInteger <> 0)
                Case 100 ' Frozen
                    ObjectX.Frozen = (sInteger <> 0)
                Case 101 ' RangeToTarget
                    ' Read Only
                Case 102 ' ActionPointsMax
                    ' Read Only
                Case 103 To 110 ' ResistanceBonusSharp, Blunt, Cold, Fire, Evil, Holy, Magic, Mind
                    ObjectX.ResistanceBonus(IntoVar - 102) = sInteger
                Case 111    ' ResistanceBonus (everthing but the specials above)
                    ObjectX.ResistanceBonus(0) = sInteger
                Case 133 ' EterniumMax
                    ' Read Only
                Case 134 ' WeightMax
                    ' Read Only
                Case 135 ' Weight
                    ' Read Only
                Case 136 ' Bulk
                    ' Read Only
                Case 137 ' StrengthBonus
                    ObjectX.StrengthBonus = sInteger
                Case 138 ' AgilityBonus
                    ObjectX.AgilityBonus = sInteger
                Case 139 ' WillBonus
                    ObjectX.WillBonus = sInteger
                Case 140 ' AttackBonus
                    ObjectX.AttackBonus = sInteger
                Case 141 ' DamageBonus
                    ObjectX.DamageBonus = sInteger
                Case 142 ' DefenseBonus
                    ObjectX.DefenseBonus = sInteger
                Case 143 ' ArmorBonus
                    ObjectX.ArmorBonus = sInteger
                Case 144 ' IsSpellCaster
                    ' Read Only
                Case 145 ' Money
                    ObjectX.Money = CLng(sInteger)
                Case 146 ' ActionPointsMax
                    ' Read Only
                Case 147 ' IsAfraid
                    ObjectX.Afraid = (sInteger <> 0)
                Case 148 ' IsInanimate
                    ObjectX.IsInanimate = (sInteger <> 0)
                Case 149 ' Not used
                Case 150 ' CombatRank
                    ObjectX.CombatRank = Greatest(Least(sInteger, 3), 0)
                Case 151 ' Pronoun_HeShe
                    ' Read Only
                Case 152 ' Pronoun_HimHer
                    ' Read Only
                Case 153 ' Pronoun_HisHer
                    ' Read Only
                Case 154 ' MovementCost
                    ' Read Only
                Case 155 ' MovementCostBonus
                    ObjectX.MovementCostBonus = sInteger
                Case 156 ' Index
                    ' Read Only
                Case 157 ' PictureFile
                    ' Validate Picture
                    Found = True
                    If Dir(frmMain.Tome.FullPath & "\" & sText) = "" Then
                        If Dir(App.Path & "\data\graphics\creatures\" & sText) = "" Then
                            Found = False
                        End If
                    End If
                    If Found = True Then
                        ObjectX.PictureFile = sText
                        frmMain.LoadCreaturePic ObjectX
                        If frmMain.picGrid.Visible = True Then
                            frmMain.CombatDraw
                        Else
                            frmMain.MenuDrawParty
                            frmMain.DrawMapAll
                        End If
                    End If
                Case 158 ' FaceLeft
                    ObjectX.FaceLeft = sInteger
                Case 159 ' FaceTop
                    ObjectX.FaceTop = sInteger
                Case 160 ' Initiative
                    ObjectX.Initiative = sInteger
                Case 161 ' Facing
                    ObjectX.Facing = Abs(Sgn(sInteger > 0))
            End Select
        Case 17, 18, 19, 20, 21 'ItemNow, ItemA, ItemB, ItemC, ItemTarget
            Set ObjectX = FrameNow.ItemX(IntoContext - 17)
            Select Case IntoVar
                Case 0 ' Resistance
                    ObjectX.Resistance = sInteger
                Case 1 ' Bulk
                    ObjectX.Bulk = sInteger
                Case 2 ' CanCombine
                    ObjectX.CanCombine = (sInteger <> 0)
                Case 3 ' ArmorType
                    ' Read Only
                Case 16 ' Capacity
                    ObjectX.Capacity = sInteger
                Case 18 ' Comments
                    ObjectX.Comments = sText
                Case 19 ' Count
                    ObjectX.Count = sInteger
                Case 20 ' DamageDice
                    ObjectX.Damage = sInteger
                Case 21 ' DamageBonus
                    ObjectX.DamageBonus = sInteger
                Case 22 ' IsWeaponMelee
                    ' Read Only
                Case 23 ' IsWeaponRanged
                    ' Read Only
                Case 24 ' IsEquipped
                    ObjectX.IsReady = (sInteger <> 0)
                    ' If the inventory window is open, redisplay.
                    If frmMain.picInventory.Visible = True Then
                        frmMain.InventoryShow 0 ' Redisplay Items in Inventory
                    End If
                Case 25 ' IsWeaponThrown
                    ' Read Only
                Case 26 ' IsKey
                    ObjectX.KeyBits = sByte
                Case 27 ' ProtectionBonusType
                    ObjectX.ResistanceType = sByte
                Case 28 ' ProtectionBonus
                    ObjectX.ResistanceBonus = sInteger
                Case 31 ' IsRangeLong
                    ObjectX.RangeType = 2
                Case 32 ' IsRangeMedium
                    ObjectX.RangeType = 1
                Case 33 ' IsRangeShort
                    ObjectX.RangeType = 0
                Case 36 ' IsSoftBulk
                    ObjectX.SoftCapacity = (sInteger <> 0)
                Case 37 ' IsDamageTypeSharp
                    ObjectX.DamageType = 1
                Case 38 ' IsDamageTypeBlunt
                    ObjectX.DamageType = 2
                Case 39 ' IsDamageTypeCold
                    ObjectX.DamageType = 3
                Case 40 ' IsDamageTypeFire
                    ObjectX.DamageType = 4
                Case 41 ' IsDamageTypeHoly
                    ObjectX.DamageType = 6
                Case 42 ' IsDamageTypeEvil
                    ObjectX.DamageType = 5
                Case 43 ' IsDamageTypeMagic
                    ObjectX.DamageType = 7
                Case 44 ' IsDamageTypeMind
                    ObjectX.DamageType = 8
                Case 50 ' MapX
                    ' Read Only
                Case 51 ' MapY
                    ' Read Only
                Case 52 ' Name
                    ObjectX.Name = sText
                Case 53 ' Defense
                    ObjectX.Defense = sInteger
                Case 54 ' Not Used
                Case 55 ' AttackBonus
                    ObjectX.AttackBonus = sInteger
                Case 56 ' UseAsDescription
                    ObjectX.UseDescription = (sInteger <> 0)
                Case 57 ' Value
                    ObjectX.Value = sInteger
                Case 58 ' Weight
                    ObjectX.Weight = sInteger
                Case 59 ' CanWearTwoHanded
                    ObjectX.WearType(13) = (sInteger <> 0)
                Case 60 ' IsInHand
                    ' Read only
                Case 61 ' IsAmmoArrow
                    ObjectX.ShootType = sByte
                Case 64 ' Family
                    If Len(sText) > 1 Then
                        x = 0
                        Do Until modBD.SetUpItemFamily(x) <> ""
                            If InStr(UCase(modBD.SetUpItemFamily(x)), UCase(sText)) > 0 Then
                                ObjectX.Family = x
                                Exit Do
                            End If
                        Loop
                    End If
                Case 65 ' ActionPoints
                    ObjectX.ActionPoints = sInteger
            End Select
        Case 22, 23, 24, 25, 26 'TriggerNow, TriggerA, TriggerB, TriggerC, TriggerTarget
            Set ObjectX = FrameNow.TriggerX(IntoContext - 22)
            Select Case IntoVar
                Case 0 'ByteA
                    ObjectX.VarA = sByte
                Case 1 'ByteB
                    ObjectX.VarB = sByte
                Case 2 'ByteC
                    ObjectX.VarC = sByte
                Case 3 'Comments
                    ObjectX.Comments = sText
                Case 4 'Not Used
                Case 5 'IsTimed
                    ObjectX.IsTimed = (sInteger <> 0)
                Case 6 'IsCurse
                    ObjectX.IsCurse = (sInteger <> 0)
                Case 7 'IsEvil
                    ObjectX.IsEvil = (sInteger <> 0)
                Case 8 'IsFear
                    ObjectX.IsFear = (sInteger <> 0)
                Case 9 'IsFish
                    ObjectX.IsFish = (sInteger <> 0)
                Case 10 'IsGreed
                    ObjectX.IsGreed = (sInteger <> 0)
                Case 11 'IsLunacy
                    ObjectX.IsLunacy = (sInteger <> 0)
                Case 12 'IsLust
                    ObjectX.IsLust = (sInteger <> 0)
                Case 13 'IsPoison
                    ObjectX.IsPoison = (sInteger <> 0)
                Case 14 'IsPride
                    ObjectX.IsPride = (sInteger <> 0)
                Case 15 'IsMagic
                    ObjectX.IsMagic = (sInteger <> 0)
                Case 16 'IsSkill
                    ObjectX.IsSkill = (sInteger <> 0)
                Case 17 'IsRevelry
                    ObjectX.IsRevelry = (sInteger <> 0)
                Case 18 'IsTrap
                    ObjectX.IsTrap = (sInteger <> 0)
                Case 19 'IsWrath
                    ObjectX.IsWrath = (sInteger <> 0)
                Case 20 'Name
                    ObjectX.Name = sText
                Case 21 'SkillPoints
                    ObjectX.SkillPoints = sInteger
                Case 22 'TriggerType
                    ' Read Only
                Case 23 ' Turns
                    ObjectX.Turns = sByte
                Case 24 ' SkillLevel
                    ' ReadOnly
            End Select
        Case 27 'Local
            Select Case IntoVar
                Case 0 'Abort
                    FrameNow.Abort = sInteger
                Case 1 'ByteA
                    FrameNow.ByteA = sByte
                Case 2 'ByteB
                     FrameNow.ByteB = sByte
                Case 3 'ByteC
                    FrameNow.ByteC = sByte
                Case 4 'Fail
                    FrameNow.Fail = sInteger
                Case 5 'IntegerA
                    FrameNow.IntegerA = sInteger
                Case 6 'IntegerB
                    FrameNow.IntegerB = sInteger
                Case 7 'IntegerC
                    FrameNow.IntegerC = sInteger
                Case 8 'StopExit
                    FrameNow.StopExit = sInteger
                Case 9 'TextA
                    FrameNow.TextA = sText
                Case 10 'TextB
                    FrameNow.TextB = sText
                Case 11 'TextC
                    FrameNow.TextC = sText
                Case 12 'Random
                    FrameNow.Random = sInteger
                Case 13 'FoundIt
                    FrameNow.FoundIt = sInteger
            End Select
        Case 28 'Global
            Select Case IntoVar
                Case 0  ' False
                    ' Read Only
                Case 1  ' True
                    ' Read Only
                Case 2 ' InCombat
                    ' Read Only
                Case 3 ' DieTypeRoll
                    ' Read Only
                Case 4 ' DieCountRoll
                    ' Read Only
                Case 5 ' ArmorRoll
                    frmMain.GlobalArmorRoll = Least(Greatest(sInteger, 1), 8)
                Case 6 ' HitRoll
                    frmMain.GlobalAttackRoll = sInteger
                Case 7 ' DamageRoll
                    sInteger = sInteger
                    frmMain.GlobalDamageRoll = sInteger
                Case 8  ' Offer
                    ' Read Only
                Case 9 To 28 ' RunePool
                    frmMain.LetRunePool IntoVar - 9, sInteger
                Case 29 ' SkillLevel
                    frmMain.GlobalSkillLevel = sInteger
                Case 58 ' IntegerA
                    frmMain.GlobalIntegerA = sInteger
                Case 59 ' IntegerB
                    frmMain.GlobalIntegerB = sInteger
                Case 60 ' IntegerC
                    frmMain.GlobalIntegerC = sInteger
                Case 61 ' TextA
                    frmMain.GlobalTextA = sText
                Case 62 ' TextB
                    frmMain.GlobalTextB = sText
                Case 63 ' TextC
                    frmMain.GlobalTextC = sText
                Case 64 ' DayName
                    frmMain.GlobalDayName = sText
                Case 65 ' MoonName
                    frmMain.GlobalMoonName = sText
                Case 66 ' YearName
                    frmMain.GlobalYearName = sText
                Case 67 ' TurnName
                    frmMain.GlobalTurnName = sText
                Case 68 ' PickLockChance
                    frmMain.GlobalPickLockChance = sInteger
                Case 69 ' Not Used
                Case 70 ' RemoveTrapChance
                    frmMain.GlobalRemoveTrapChance = sInteger
                Case 71 ' HitLocation
                    ' Read Only
                Case 71 ' HitLocation
                    frmMain.GlobalHitLocation = sInteger
                Case 72 ' SpellFizzleChance
                    frmMain.GlobalSpellFizzleChance = sInteger
                Case 73 ' Ticks
                    frmMain.GlobalTicks = sInteger
            End Select
        Case 29 'Pos
            ' Read only at run-time
        Case 30 'Neg
            ' Read only at run-time
        Case 31 'Dice
            ' Read only at run-time
        Case 32 'Random
            ' Read only at run-time
    End Select
End Sub
