VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ThemeSketch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Version number of Class
Dim myVersion As Integer
' Unique number for this Theme
Dim myIndex As Integer
' Name of Theme
Dim myName As String
' Comments for Theme
Dim myComments As String
' Created for Party Size
' Bit1-2 - 0 = Solo, 1 = 2-3, 2 = 4-6, 3 = 7-9
' With Average Party Level
' Bit3-4 - 0 = 1-3, 1 = 4-6, 2 = 7-10, 3 = 10+
' Bit5-8 (MapStyle)
'       0 - Town Map
'       1 - Wilderness Map
'       2 - Building Map
'       3 - Dungeon Map
' Bit9-16 - Not Used
Dim myStyle As Integer
' Bit1      - IsQuest? (Can span multiple maps) On=Yes, Off=No
' Bit2      - On=IsUsed Off=Not
' Bit3      - On=IsSelected, Off=Not
' Bit4      - IsMajorTheme? On=Yes, Off=No
' Bit5-7    - Not Used
Dim myFlags As Integer
' Amount of Encounters this should create
Dim myCoverage As Integer
' Path where File is located
Dim myFullPath As String

Public Property Get Version() As Integer
    Version = myVersion
End Property

Public Property Let Version(NewValue As Integer)
    myVersion = NewValue
End Property

Public Property Get FullPath() As String
    FullPath = Trim(myFullPath)
End Property

Public Property Let FullPath(NewValue As String)
    myFullPath = Trim(NewValue)
End Property

Public Property Get Name() As String
    Name = Trim(myName)
End Property

Public Property Let Name(NewValue As String)
    myName = Trim(NewValue)
End Property

Public Property Get Comments() As String
    Comments = Trim(myComments)
End Property

Public Property Let Comments(NewValue As String)
    myComments = Trim(NewValue)
End Property

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewValue As Integer)
    myIndex = NewValue
End Property

Public Property Get Flags() As Integer
    Flags = myFlags
End Property

Public Property Let Flags(NewValue As Integer)
    myFlags = NewValue
End Property

Public Property Get IsQuest() As Integer
    IsQuest = (myFlags And &H1) > 0
End Property

Public Property Let IsQuest(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H1
    Else
        myFlags = myFlags And (Not &H1)
    End If
End Property

Public Property Get IsMajorTheme() As Integer
    IsMajorTheme = (myFlags And &H8) > 0
End Property

Public Property Let IsMajorTheme(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H8
    Else
        myFlags = myFlags And (Not &H8)
    End If
End Property

Public Property Get IsUsed() As Integer
    IsUsed = (myFlags And &H2) > 0
End Property

Public Property Let IsUsed(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H2
    Else
        myFlags = myFlags And (Not &H2)
    End If
End Property

Public Property Get IsSelected() As Integer
    IsSelected = (myFlags And &H4) > 0
End Property

Public Property Let IsSelected(NewValue As Integer)
    If NewValue Then
        myFlags = myFlags Or &H4
    Else
        myFlags = myFlags And (Not &H4)
    End If
End Property

Public Property Get PartySize() As Integer
    PartySize = CInt(myStyle And &H3)
End Property

Public Property Let PartySize(NewValue As Integer)
    myStyle = myStyle And &HFFFC
    myStyle = myStyle Or (NewValue And &H3)
End Property

Public Property Get PartyAvgLevel() As Integer
    PartyAvgLevel = CInt((myStyle And &HC) / 4)
End Property

Public Property Let PartyAvgLevel(NewValue As Integer)
    myStyle = myStyle And &HFFF3
    myStyle = myStyle Or (NewValue * 4 And &HC)
End Property

Public Sub IncreaseDifficulty()
    ' Max is 3 and 3 in both
    If Me.PartySize = 3 And Me.PartyAvgLevel = 3 Then
        Exit Sub
    End If
    ' Increase PartySize and AvgLevel by 1 degree
    Select Case Me.PartySize * 4 + Me.PartyAvgLevel
        Case 3, 7, 11
            Me.PartySize = Me.PartySize + 1
            Me.PartyAvgLevel = 0
        Case Else
            Me.PartyAvgLevel = Me.PartyAvgLevel + 1
    End Select
End Sub

Public Property Get Difficulty() As Integer
    Dim c As Integer
    Select Case Me.PartyAvgLevel
        Case 0  ' 1-3
            c = 1
        Case 1  ' 4-6
            c = 3
        Case 2  ' 7-10
            c = 6
        Case 3  ' 10+
            c = 12
    End Select
    Select Case Me.PartySize
        Case 0  ' Solo
            Difficulty = 1 * c
        Case 1  ' 2-3
            Difficulty = 3 * c
        Case 2  ' 4-6
            Difficulty = 5 * c
        Case 3  ' 7-9
            Difficulty = 10 * c
    End Select
End Property

Public Property Get Coverage() As Integer
    Coverage = myCoverage
End Property

Public Property Let Coverage(NewValue As Integer)
    myCoverage = NewValue
End Property

Public Property Get Style() As Integer
    Style = myStyle
End Property

Public Property Let Style(NewValue As Integer)
    myStyle = NewValue
End Property

Public Property Get MapStyle() As Integer
    MapStyle = CInt((myStyle And &HF0) / 16)
End Property

Public Property Let MapStyle(NewValue As Integer)
    myStyle = myStyle And &HFF0F
    myStyle = myStyle Or (NewValue * 16 And &HF0)
End Property

Public Sub Copy(ThemeSketchX As ThemeSketch)
    myVersion = ThemeSketchX.Version
    myName = ThemeSketchX.Name
    myComments = ThemeSketchX.Comments
    myStyle = ThemeSketchX.Style
    myFlags = ThemeSketchX.Flags
    myFullPath = ThemeSketchX.FullPath
End Sub
