VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TomeSketch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Unique Index
Private myIndex As Integer
' Name of Tome
Private myName As String
' Comments for Tome
Private myComments As String
' Location of Tome File
Private myFullPath As String
' If a Tome Map: Max number of Creatures in the Party. 0 is no max.
Private myPartySize As Byte
' If a Tome Map: Max amount of Level in Party. 0 is no max.
Private myPartyAvgLevel As Byte

' Collection of Creature Objects which make up the Party. Upon arriving
' at MainMenu, this is emptied of all CreatureWithTurns (they are saved back into
' the Pool).
Private myCreatures As New Collection
' Triggers which follow with Party. Upon arriving at MainMenu, this
' is cleared.
Private myTriggers As New Collection
' Journal Entries attached to this Tome
Private myJournals As New Collection
' This is the list of Factoids accquired by the Party.
Private myFactoids As New Collection

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewValue As Integer)
    myIndex = NewValue
End Property

Public Property Get Name() As String
    Name = Trim(myName)
End Property

Public Property Let Name(NewName As String)
    myName = Trim(NewName)
End Property

Public Property Get Comments() As String
    Comments = Trim(myComments)
End Property

Public Property Let Comments(NewComments As String)
    myComments = Trim(NewComments)
End Property

Public Property Get FullPath() As String
    FullPath = Trim(myFullPath)
End Property

Public Property Let FullPath(NewFullPath As String)
    myFullPath = Trim(NewFullPath)
End Property

Public Property Get PartySize() As Integer
    PartySize = myPartySize
End Property

Public Property Let PartySize(NewValue As Integer)
    myPartySize = NewValue
End Property

Public Property Get PartyAvgLevel() As Integer
    PartyAvgLevel = myPartyAvgLevel
End Property

Public Property Let PartyAvgLevel(NewValue As Integer)
    myPartyAvgLevel = NewValue
End Property

Public Property Get Triggers() As Collection
    Set Triggers = myTriggers
End Property

Public Function AddTrigger() As Trigger
    ' Adds a Trigger and returns a reference to that Trigger
    Dim c As Integer
    Dim TriggerX As Trigger
    ' Find new available unused index idenifier
    c = 1
    For Each TriggerX In myTriggers
        If TriggerX.Index >= c Then
            c = TriggerX.Index + 1
        End If
    Next TriggerX
    ' Create the Trigger, set the Index and add it.
    Set TriggerX = New Trigger
    TriggerX.Index = c
    TriggerX.Name = "Trigger" & c
    myTriggers.Add Item:=TriggerX, Key:="T" & TriggerX.Index
    Set AddTrigger = TriggerX
End Function

Public Sub RemoveTrigger(DeleteKey As String)
    myTriggers.Remove DeleteKey
End Sub

Public Property Get Creatures() As Collection
    Set Creatures = myCreatures
End Property

Public Function AddCreature() As Creature
    ' Adds a Trigger and returns a reference to that Trigger
    Dim c As Integer
    Dim CreatureX As Creature
    ' Find new available unused index idenifier
    c = 1
    For Each CreatureX In myCreatures
        If CreatureX.Index >= c Then
            c = CreatureX.Index + 1
        End If
    Next CreatureX
    ' Create the Trigger, set the Index and add it.
    Set CreatureX = New Creature
    CreatureX.Index = c
    CreatureX.Name = "Creature" & c
    myCreatures.Add Item:=CreatureX, Key:="X" & CreatureX.Index
    Set AddCreature = CreatureX
End Function

Public Sub AppendCreature(CreatureX As Creature)
    ' Adds a Trigger and returns a reference to that Trigger
    Dim c As Integer
    Dim CreatureZ As Creature
    ' Find new available unused index idenifier
    c = 1
    For Each CreatureZ In myCreatures
        If CreatureZ.Index >= c Then
            c = CreatureZ.Index + 1
        End If
    Next CreatureZ
    ' Create the Trigger, set the Index and add it.
    CreatureX.Index = c
    myCreatures.Add Item:=CreatureX, Key:="X" & CreatureX.Index
End Sub

Public Sub RemoveCreature(DeleteKey As String)
    myCreatures.Remove DeleteKey
End Sub

Public Property Get Factoids() As Collection
    Set Factoids = myFactoids
End Property

Public Function AddFactoid() As Factoid
    ' Adds a Factoid and returns a reference to that Factoid
    Dim c As Integer
    Dim FactoidX As Factoid
    ' Find new available unused index idenifier
    c = 1
    For Each FactoidX In myFactoids
        If FactoidX.Index >= c Then
            c = FactoidX.Index + 1
        End If
    Next FactoidX
    ' Create the Factoid, set the Index and add it.
    Set FactoidX = New Factoid
    FactoidX.Index = c
    myFactoids.Add Item:=FactoidX, Key:="F" & FactoidX.Index
    Set AddFactoid = FactoidX
End Function

Public Sub RemoveFactoid(DeleteKey As String)
    myFactoids.Remove DeleteKey
End Sub

Public Property Get Journals() As Collection
    Set Journals = myJournals
End Property

Public Function AddJournal() As Journal
    ' Adds a Journal and returns a reference to that Journal
    Dim c As Integer
    Dim JournalX As Journal
    ' Find new available unused index idenifier
    c = 1
    For Each JournalX In myJournals
        If JournalX.Index >= c Then
            c = JournalX.Index + 1
        End If
    Next JournalX
    ' Create the Journal, set the Index and add it.
    Set JournalX = New Journal
    JournalX.Index = c
    myJournals.Add Item:=JournalX, Key:="J" & JournalX.Index
    Set AddJournal = JournalX
End Function

Public Sub RemoveJournal(DeleteKey As String)
    myJournals.Remove DeleteKey
End Sub

