VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "UberWizard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private myVersion As Integer
Private myMainMapIndex As Integer
Private myMakingMapIndex As Integer

' Name of Plot (.rsa file) to jump to when hit this entry point
Private myAreaIndex As Integer
' Name of Map within above Plot to jump to.
Private myMapIndex As Integer
' Name of EntryPoint within above Map.
Private myEntryIndex As Integer

' Index of Major Theme (<1 if not selected)
Private myMajorThemeIndex As Integer

' Tome Information
Private myTomeName As String
Private myTomeComments As String
Private myTomePartySize As Byte
Private myTomePartyAvgLevel As Byte
Private myTotalSize As Long

' Various collections
Private myExcludeDirs As New Collection
Private myTomeSketchs As New Collection
Private myMapSketchs As New Collection
Private myThemeSketchs As New Collection
Private myCreatures As New Collection
Private myItems As New Collection
Private myTomeFiles As New Collection
Private myMapFiles As New Collection
Private myThemeFiles As New Collection
Private myCreatureFiles As New Collection
Private myItemFiles As New Collection

Public Property Get TomeName() As String
    TomeName = Trim(myTomeName)
End Property

Public Property Let TomeName(NewTomeName As String)
    myTomeName = Trim(NewTomeName)
End Property

Public Property Get TomeComments() As String
    TomeComments = Trim(myTomeComments)
End Property

Public Property Let TomeComments(NewTomeComments As String)
    myTomeComments = Trim(NewTomeComments)
End Property

Public Property Get TomePartySize() As Integer
    TomePartySize = myTomePartySize
End Property

Public Property Let TomePartySize(NewValue As Integer)
    myTomePartySize = NewValue
End Property

Public Property Get TomePartyAvgLevel() As Integer
    TomePartyAvgLevel = myTomePartyAvgLevel
End Property

Public Property Let TomePartyAvgLevel(NewValue As Integer)
    myTomePartyAvgLevel = NewValue
End Property

Public Property Get TotalSize() As Long
    TotalSize = myTotalSize
End Property

Public Property Let TotalSize(NewValue As Long)
    myTotalSize = NewValue
End Property

Public Property Get Difficulty() As Integer
    Dim c As Integer
    Select Case Me.TomePartyAvgLevel
        Case 0  ' 1-3
            c = 1
        Case 1  ' 4-6
            c = 3
        Case 2  ' 7-10
            c = 6
        Case 3  ' 10+
            c = 12
    End Select
    Select Case Me.TomePartySize
        Case 0  ' Solo
            Difficulty = 1 * c
        Case 1  ' 2-3
            Difficulty = 3 * c
        Case 2  ' 4-6
            Difficulty = 5 * c
        Case 3  ' 7-9
            Difficulty = 10 * c
    End Select
End Property

Public Property Get Version() As Integer
    Version = myVersion
End Property

Public Property Let Version(NewValue As Integer)
    myVersion = NewValue
End Property

Public Property Get AreaIndex() As Integer
    AreaIndex = myAreaIndex
End Property

Public Property Let AreaIndex(NewValue As Integer)
    myAreaIndex = NewValue
End Property

Public Property Get MapIndex() As Integer
    MapIndex = myMapIndex
End Property

Public Property Let MapIndex(NewValue As Integer)
    myMapIndex = NewValue
End Property

Public Property Get EntryIndex() As Integer
    EntryIndex = myEntryIndex
End Property

Public Property Let EntryIndex(NewValue As Integer)
    myEntryIndex = NewValue
End Property

Public Function AddTomeSketch() As TomeSketch
    ' Adds an TomeSketch and returns a reference to that TomeSketch
    Dim c As Integer
    Dim TomeSketchX As TomeSketch
    ' Find new available unused index idenifier
    c = 1
    For Each TomeSketchX In myTomeSketchs
        If TomeSketchX.Index >= c Then
            c = TomeSketchX.Index + 1
        End If
    Next TomeSketchX
    ' Set the index and add the TomeSketch. Return the new TomeSketchs index.
    Set TomeSketchX = New TomeSketch
    TomeSketchX.Index = c
    myTomeSketchs.Add Item:=TomeSketchX, Key:="T" & TomeSketchX.Index
    Set AddTomeSketch = TomeSketchX
End Function

Public Sub RemoveTomeSketch(DeleteKey As String)
    ' Remove TomeSketch
    myTomeSketchs.Remove DeleteKey
End Sub

Public Property Get TomeSketchs() As Collection
    Set TomeSketchs = myTomeSketchs
End Property

Public Function AddMapSketch() As MapSketch
    ' Adds an MapSketch and returns a reference to that MapSketch
    Dim c As Integer
    Dim MapSketchX As MapSketch
    ' Find new available unused index idenifier
    c = 1
    For Each MapSketchX In myMapSketchs
        If MapSketchX.Index >= c Then
            c = MapSketchX.Index + 1
        End If
    Next MapSketchX
    ' Set the index and add the MapSketch. Return the new MapSketchs index.
    Set MapSketchX = New MapSketch
    MapSketchX.Index = c
    myMapSketchs.Add Item:=MapSketchX, Key:="M" & MapSketchX.Index
    Set AddMapSketch = MapSketchX
End Function

Public Sub RemoveMapSketch(DeleteKey As String)
    ' Remove MapSketch
    myMapSketchs.Remove DeleteKey
End Sub

Public Property Get MapSketchs() As Collection
    Set MapSketchs = myMapSketchs
End Property

Public Property Set MapSketchs(NewValue As Collection)
    Set myMapSketchs = NewValue
End Property


Public Function AddThemeSketch() As ThemeSketch
    ' Adds an ThemeSketch and returns a reference to that ThemeSketch
    Dim c As Integer
    Dim ThemeSketchX As ThemeSketch
    ' Find new available unused index idenifier
    c = 1
    For Each ThemeSketchX In myThemeSketchs
        If ThemeSketchX.Index >= c Then
            c = ThemeSketchX.Index + 1
        End If
    Next ThemeSketchX
    ' Set the index and add the ThemeSketch. Return the new ThemeSketchs index.
    Set ThemeSketchX = New ThemeSketch
    ThemeSketchX.Index = c
    myThemeSketchs.Add Item:=ThemeSketchX, Key:="R" & ThemeSketchX.Index
    Set AddThemeSketch = ThemeSketchX
End Function

Public Sub RemoveThemeSketch(DeleteKey As String)
    ' Remove ThemeSketch
    myThemeSketchs.Remove DeleteKey
End Sub

Public Property Get ThemeSketchs() As Collection
    Set ThemeSketchs = myThemeSketchs
End Property

Public Property Set ThemeSketchs(NewValue As Collection)
    Set myThemeSketchs = NewValue
End Property

Public Function AddCreature() As Creature
    ' Adds an Creature and returns a reference to that Creature
    Dim c As Integer
    Dim CreatureX As Creature
    ' Find new available unused index idenifier
    c = 1
    For Each CreatureX In myCreatures
        If CreatureX.Index >= c Then
            c = CreatureX.Index + 1
        End If
    Next CreatureX
    ' Set the index and add the Creature. Return the new Creatures index.
    Set CreatureX = New Creature
    CreatureX.Index = c
    myCreatures.Add Item:=CreatureX, Key:="X" & CreatureX.Index
    Set AddCreature = CreatureX
End Function

Public Sub RemoveCreature(DeleteKey As String)
    ' Remove Creature
    myCreatures.Remove DeleteKey
End Sub

Public Property Get Creatures() As Collection
    Set Creatures = myCreatures
End Property

Public Property Set Creatures(NewValue As Collection)
    Set myCreatures = NewValue
End Property

Public Function AddItem() As Item
    ' Adds an Item and returns a reference to that Item
    Dim c As Integer
    Dim ItemX As Item
    ' Find new available unused index idenifier
    c = 1
    For Each ItemX In myItems
        If ItemX.Index >= c Then
            c = ItemX.Index + 1
        End If
    Next ItemX
    ' Set the index and add the Item. Return the new Items index.
    Set ItemX = New Item
    ItemX.Index = c
    myItems.Add Item:=ItemX, Key:="I" & ItemX.Index
    Set AddItem = ItemX
End Function

Public Sub RemoveItem(DeleteKey As String)
    ' Remove Item
    myItems.Remove DeleteKey
End Sub

Public Property Get Items() As Collection
    Set Items = myItems
End Property

Public Property Set Items(NewValue As Collection)
    Set myItems = NewValue
End Property

Public Property Get ExcludeDirs() As Collection
    Set ExcludeDirs = myExcludeDirs
End Property

Public Property Get TomeFiles() As Collection
    Set TomeFiles = myTomeFiles
End Property

Public Property Get MapFiles() As Collection
    Set MapFiles = myMapFiles
End Property

Public Property Get CreatureFiles() As Collection
    Set CreatureFiles = myCreatureFiles
End Property

Public Property Get ThemeFiles() As Collection
    Set ThemeFiles = myThemeFiles
End Property

Public Property Get ItemFiles() As Collection
    Set ItemFiles = myItemFiles
End Property

Public Property Get MainMap() As MapSketch
    Set MainMap = myMapSketchs("M" & myMainMapIndex)
End Property

Public Property Get MainMapIndex() As Integer
    MainMapIndex = myMainMapIndex
End Property

Public Property Let MainMapIndex(NewValue As Integer)
    myMainMapIndex = NewValue
End Property

Public Property Get MajorThemeIndex() As Integer
    MajorThemeIndex = myMajorThemeIndex
End Property

Public Property Let MajorThemeIndex(NewValue As Integer)
    myMajorThemeIndex = NewValue
End Property

Public Property Get MakingMap() As MapSketch
    Set MakingMap = myMapSketchs("M" & myMakingMapIndex)
End Property

Public Property Get MakingMapIndex() As Integer
    MakingMapIndex = myMakingMapIndex
End Property

Public Property Let MakingMapIndex(NewValue As Integer)
    myMakingMapIndex = NewValue
End Property
