VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "World"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Name of the World
Private myName As String
' Index of World
Private myIndex As Integer
' File Name of Map for World
Private myPictureFile As String
' Tome Name of Tome (containing Creature templates) for World
Private myTomeName As String

' Actual Tome for World
Private myTome As Tome
' Current Creature in Tome used as Template
Private myTemplate As Creature
' CreatureWithTurn being built from CreatureTmplt
Private myCreatureWithTurn As Creature
' Stat adjusting
Private myAdjustStat As Integer

Private myKingdoms As New Collection

Public Property Get Name() As String
    Name = myName
End Property

Public Property Let Name(NewValue As String)
    myName = NewValue
End Property

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewValue As Integer)
    myIndex = NewValue
End Property

Public Function AddKingdom() As Kingdom
    ' Adds an Kingdom and returns a reference to that Kingdom
    Dim c As Integer
    Dim KingdomX As Kingdom
    ' Find new available unused index idenifier
    c = 1
    For Each KingdomX In myKingdoms
        If KingdomX.Index >= c Then
            c = KingdomX.Index + 1
        End If
    Next KingdomX
    ' Set the index and add the door. Return the new door's index.
    Set KingdomX = New Kingdom
    KingdomX.Index = c
    myKingdoms.Add Item:=KingdomX, Key:="K" & KingdomX.Index
    Set AddKingdom = KingdomX
End Function

Public Property Get Kingdoms() As Collection
    Set Kingdoms = myKingdoms
End Property

Public Property Get PictureFile() As String
    PictureFile = myPictureFile
End Property

Public Property Let PictureFile(NewValue As String)
    myPictureFile = NewValue
End Property

Public Property Get TomeName() As String
    TomeName = myTomeName
End Property

Public Property Let TomeName(NewValue As String)
    myTomeName = NewValue
End Property

Public Property Get Tome() As Tome
    Set Tome = myTome
End Property

Public Property Set Tome(NewValue As Tome)
    Set myTome = NewValue
End Property

Public Property Get Template() As Creature
    Set Template = myTemplate
End Property

Public Property Set Template(NewValue As Creature)
    Set myTemplate = NewValue
End Property

Public Property Get CreatureWithTurn() As Creature
    Set CreatureWithTurn = myCreatureWithTurn
End Property

Public Property Set CreatureWithTurn(NewValue As Creature)
    Set myCreatureWithTurn = NewValue
End Property

Public Property Get AdjustStat() As Integer
    AdjustStat = myAdjustStat
End Property

Public Property Let AdjustStat(NewValue As Integer)
    myAdjustStat = NewValue
End Property
